C
C
C     PROMET New generation    
C     Version 6.0 
C     common space groups for Z'=1 and Z'=1/2
C
C     novemeber 1998-january 1999
C
      dimension ki(12),titolo(10)
      common/moldim/volu,dmomax,dmomed,dmomin
      COMMON/ORIG/MOP(3),JOP(3),KOP(3),ITRS(3),TFIRST(3,3),ITRSA(3)
      COMMON/TIPI/ WEI(30),RAVDW(30),RAVRG(30),FL(30)
      COMMON/OPEC1/ALFA(7000,3),RM(800,3,3),QRG(120),NPE
      COMMON/OPEC2/ PESO(120),CUTOFF,ILEVEL(5),ISPEN(120),TIPO(15,15,3),
     1 NATOM,NA,NAA,NB,NC,ND,NE,NF,NG,NH,NI,NL,NM,NEE,NEM,NEF,NEL,NEP,
     2 NDD,NDE,NDF,NDG,NDH
      COMMON/HALF/ HALF,nsomax
      COMMON/SY/ISWM,nspgr(3)   
      COMMON /VARIA/ AX5,NMOL,CUT2,ESUB,FD1,FD2,FD3,FD4, NTOP,IWAR(3)
      common/ndim/nwpe,nrm,nalf,nwatom,nalmax
      NWPE=150
      NRM=800
      NALF=7000
      NWATOM=120
      NA=NWPE
      NAA=2*NWPE
      NB=NAA+1+NWPE
      NC=NB+1
      ND=NC+1
      NE=NWATOM+1
      NF=NWATOM+9
      NG=NF+1
      NH=NG
      NI=NH+NWPE
      NL=NI+NWPE
      NM=NL+NWPE
      NEE=NE+1
      NEM=NE+2
      NEF=NE+3
      NEL=NE+4
      NEP=NE+5
      NDD=ND+1
      NDE=ND+2
      NDF=ND+3
      NDG=ND+4
      NDH=ND+5
      do 891 i=1,12
 891  ki(i)=1
C     PRELIMINARIES
      OPEN (unit=1,file='fort.1')
      open (unit=2,file='fort.2')
      open (unit=3,file='fort.3')
      open (unit=8,file='fort.8')
      open (unit=10,file='fort.10')
      open (unit=11,file='fort.11')
      DO 1001 I=1,NALF
      DO 1001 J=1,3
      nspgr(j)=0
 1001 ALFA(I,J)=0.0
      DO 1002 I=1,NRM
      DO 1002 J=1,3
      DO 1002 K=1,3
 1002 RM(I,J,K)=0.0
C     INSERT IDENTITY MATRIX
      DO 1003 I=1,3
 1003 RM(1,I,I)=1.0
      DO 911 I=1,NWATOM
      PESO(I)=0.0
      ISPEN(I)=0
 911  CONTINUE
      READ(1,1) (TITOLO(I),I=1,10)
      WRITE(6,2) (TITOLO(I),I=1,10)
      write(8,2) titolo
 1    FORMAT(10a4)
 2    FORMAT(2X,' PROMET VERSION 6.0',2x,10a4)
      READ(1,1200) ILEVEL,CUTOFF,CUTRAS,HALF
 1200 FORMAT(5I1,4F10.0)        
C     SET DEFAULTS
      RIDIC=0.00001
      IF(CUTOFF.LT.RIDIC) CUTOFF=7.0
      IF(CUTRAS.LT.RIDIC) CUTRAS=10.0
      IF(CUTOFF.GT.7.0) CALL ERR
      IF(ABS(HALF).LT.RIDIC) HALF=0.51
c     if isce eq 0 search clusters only, not 3D structures
c     in normal operation isce=1
      isce=0
      if(ilevel(1).eq.0) isce=1
      read(1,*) natom
      do 933 i=1,natom
      read(1,*) ispen(i),(alfa(i,j),j=1,3),peso(i),rawxx,qrg(i)
      ispene=ispen(i)
      IF(RAWXX.GT.0.01) RAVDW(ISPENE)=RAWXX
 933  continue
      WRITE(8,351)
 351  FORMAT(/2X,'Atom ,coordinates,weight,species,charge,radius')
      DO 353 I=1,NATOM
      ISPX=ISPEN(I)
      ROCK=RAVDW(ISPX)
      WRITE(8,354) I,(ALFA(I,K),K=1,3),PESO(I),ISPEN(I),QRG(I),ROCK
 354   FORMAT (1X,I4,1X,3F8.3,2X,F8.2,3X,I3,1X,F6.2,1X,F7.3)
 353   CONTINUE
c     dummy call to orthogonalization subroutine
      NPE=1
      CALL MATORT(1.0,1.0,1.0,90.,90.,90.) 
C     READ ATOM-ATOM POTENTIALS
      CALL REDEN
 603  CONTINUE
c     fill local reference system matrix by default with identity
      novec=nl+1
      nomat=na+1
      do 777 i=1,3
      alfa(novec,i)=0.0
      do 779 j=1,3
 779  rm(nomat,i,j)=0.0
 777  rm(nomat,i,i)=1.0
      call wrma(novec,nomat,1)
c
c     new input description starts here
c
c     prepare common things
c     expected packing energy and expected threshold energy
      write(6,3001)
 3001 format(2x,'welcome to promet.6'/
     1 2x,'how many h-bonds can the molecule form?')
      read(5,*) nhbo
      write(6,661)
 661  format(/2x,'molecular symmetry'/
     1 2x,'type I, M, A, or N')
      read(5,662) rla
 662  format(a1)
      iswm=1
      nexta=natom
      if(rla.eq.'N') iswm=0
C     set molecule in inertial reference system     
c     if necessary
      if(iswm.eq.0) call setup (1)
      if(iswm.eq.0) go to 778
c     molecule has internal symmetry
      if(rla.eq.'I') intern=1
      if(rla.eq.'A') intern=2
      if(rla.eq.'M') intern=3
 778  continue       
      call tesgeo(iswm,intern)
c     set molecular dimensions for special cases
      rat=dmomax/dmomin
      if(rat.lt.1.3) dmomax=1.3*dmomin
c     if(rat.gt.1.8) dmomax=1.8*dmomin
c     if(rat.gt.2.5) dmomax=2.2*dmomin
      write(6,772)
 772  format(2x,'any guess at lattice energy(<0)?'/
     1 2x,'if not give zero')
      read(5,*) expe
      if(abs(expe).lt.ridic) go to 781
      expe=0.8*expe
      go to 782
 781  volup=volu
      if(iswm.ne.0) volup=2.0*volu
      expe=-0.5*(0.55*volup+70.0+20.0*nhbo)
      expe=expe-(0.1*expe)*(7.0-cutoff)
      if(volup.lt.100.) expe=0.9*expe
c     max translation vector in 3D packt subroutine
 782  axis=(dmomax+cutras)*1.5
      ax5=axis*axis
      cut2=cutoff*cutoff
      write(8,1231) volu,dmomin,dmomax
      write(6,1231) volu,dmomin,dmomax
 1231 format(1x,'volume of asymmetric unit is',f10.2/
     1 1x,'max and min molecular dimension',2f12.3)
      WRITE(6,1201) CUTOFF,CUTRAS,HALF
      write(8,1201) cutoff,cutras,half
 1201 FORMAT( /2X,'Cutoff at',F8.2,1X,'and at',F8.2,1X,'in minopec'/,
     1 /2X,'min val of cosine of cell angles is',1X,F10.4)
      write(8,3002) expe,axis
      write(6,3002) expe,axis
 3002 format(2x,'expected packing energy',f10.2,2x,'kJ/mol'/
     1 2x,'max translation vector in packt 3D',f10.2)
      write(6,3003)
 3003 format(2x,'give control parameters for Es and ranges'/
     12x,'must be two numbers between 0.0 and 1.0')
      read(5,*) fudge,fudgf
      write(8,3004) fudge,fudgf
      write(6,3004) fudge,fudgf
 3004 format(2x,'energy resolution level',f8.2/
     1 2x,'step resolution level',f8.2) 
c     set energy thresholds and steps according to
c     resolution levels
      esub=0.5*expe+0.4*expe*fudge
      steul=10.+20.*fudgf
      isteul=steul
      stefi=10.0+20.0*fudgf
      staxis=0.5+0.6*fudgf
      rme1=0.5+0.6*fudgf
      rme5=0.25+0.30*fudgf
      rme25=0.125+0.15*fudgf
      ckm=0.65-0.3*(1.0-fudge)
      ckp=0.75
      write(6,563)
  563 format(2x,'give max number of structures (zero=take all)')
      read(5,*) nsomax
      if(nsomax.eq.0) nsomax=99999
c     read lower limit for Sy and Gyz first search
      write(6,564)
 564  format(2x,'give low lim for Sy and Gyz, 0=take defaults')
      read(5,*) ymsy
c     if molecule has internal symmetry, skip P21 and P212121
      if(iswm.ne.0) go to 671
 670  continue
      write(6,663) 
 663  format(2x,'type 1 if space group is chiral, 0 otherwise')
      read(5,*) ichi
      if(ichi.eq.0) go to 671
c     space group is chiral,P21 and P212121 sequence
c     stop if molecule has internal symmetry
      if(iswm.ne.0) call err
      mop(1)=3
      jop(1)=2
      kop(1)=2
      itrsa(2)=0
      itrsa(1)=0
      write(6,1105)
 1105 format(2x,'do you want to search space group P21 (1 yes, 0 no)')
      read(5,*) isp21 
      if(isp21.eq.0) go to 2011
      nspgr(1)=1
      ki(4)=0
      ki(6)=0
      ki(8)=0
      itrsa(1)=isce
      write(6,1106)
 1106 format(2x,'any guess at a,b,c for P21? (0=no, 1=yes)')
      read(5,*) icp21
      if(icp21.eq.0) go to 2012
c     search P21 only with guessed a,b,c
      read(5,*) ague,bgue,cgue
      itrsa(1)=1
      ymi=0.5*bgue
      yma=ymi+0.30
      ami=ague
      ama=ami+0.6
      cmi=cgue
      cma=cgue+0.6
      edg1=0.4*esub+0.3*esub*fudge
      zma=dmomax*(1.5-0.5*fudgf)
 1102 write(3,694) 0.,0.,0.,ymi,yma,0.25,1.0,zma,rme1
      write(3,695) 0,340,0,340,0,160,isteul,edg1
 695  format(7i5,2f10.2)
 694  format(9f10.3)
      call write9 (65,65,esub,axis,ckm,ckp,ki,ami,ama,0.,0.,cmi,cma,
     10.5,0.0,0.5,0.,0.,0.,0.,0.,0.,0.,0.,0.,-90.,90.,0.,0.,
     2 -90.,90.,stefi,0.,stefi)
c     go to structure search for P21, guessed cell parameters
      go to 2025 
 2012 continue
c     set automatic limits for P21 search
      ymi=ymsy
      if(ymi.lt.0.01) ymi=dmomin*0.3
      if(ymi.lt.2.0) ymi=2.0
      yma=dmomax*(1.0-0.4*fudgf) 
      zma=dmomax*(1.0-0.7*fudgf)    
      edg1=0.4*esub+0.3*esub*fudge
      ami=4.
      ama=dmomax*(1.8-0.6*fudgf)
      cmi=4.
      cma=dmomax*(1.8-0.6*fudgf)
      write(3,694) 0.,0.,0.,ymi,yma,rme5,1.0,zma,rme1    
      write(3,695) 0,340,0,340,0,160,isteul,edg1
      call write9 (65,65,esub,axis,ckm,ckp,ki,ami,ama,0.,0.,cmi,cma,
     1 staxis,0.,staxis,0.,0.,0.,0.,0.,0.,0.,0.,0.,-90.,90.,0.,0.,
     2 -90.,90.,stefi,0.,stefi) 
      write(6,1109)
 1109 format(2x,'want to search P212121 too? (1 yes, 0 no)')
      read(5,*) isk
c     if no P212121 is wanted, go to cell search for P21
      if(isk.eq.0) go to 2025
c     automatic search for P212121 after P21
      nspgr(2)=2
      itrsa(2)=isce
      mop(2)=3
      jop(2)=3
      kop(2)=3
      xma=dmomax*(0.65-0.2*fudgf)
      zma=dmomax*(1.3-0.4*fudgf)
      yma2=0.8*yma
      edg1=esub
      ckm=0.60-(1.0-fudge)*0.3
 1104 write(3,694) 1.3,xma,rme25,0.0,yma2,rme1,2.,zma,rme5
      write(3,695) 0,340,0,0,0,0,isteul,edg1
 2022 ki(4)=0
      ki(5)=0
      ki(6)=0
      ki(8)=1
      call write9 (69,71,esub,axis,ckm,ckp,ki,0.,0.,0.,0.,0.,0.,0.,0.,
     1 0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.)
      go to 2025
c     search P212121 only 
 2011 continue
      nspgr(2)=2
      mop(2)=3
      jop(2)=3
      kop(2)=3
      itrsa(1)=0
      itrsa(2)=isce
c     set specs for screw axis search
      ymi1=ymsy
      if(ymi1.lt.0.01) ymi1=dmomin*0.3
      if(ymi1.lt.2.0) ymi1=2.0
      yma1=dmomax*(1.0-0.4*fudgf)
      zma1=dmomax*(1.0-0.7*fudgf)
      edg11=0.4*esub+0.3*esub*fudge
      write(6,1108)
 1108 format(2x,'any guess at p212121 cell parameters? (1 yes, 0 no)')
      read(5,*)icp212
      if(icp212.eq.0) go to 2015
      read(5,*) ague,bgue,cgue
      itrsa(2)=1
      xmi2=ague*0.25
      xma2=xmi2+0.30
      zmi2=cgue*0.50
      zma2=zmi2+0.55
      ymi1=0.5*bgue
      yma1=ymi1+0.55
      yma2=0.8*yma1
      go to 2020
 2015 continue
      xmi2=1.3
      xma2=0.65*dmomax-0.2*fudgf*dmomax
      yma2=0.8*yma1
      zmi2=2.0
      zma2=1.3*dmomax-0.4*fudgf*dmomax
 2020 continue
      edg12=esub
      write(3,694) 0.,0.,0.,ymi1,yma1,rme5,1.0,zma1,rme1
      write(3,695) 0,340,0,340,0,160,isteul,edg11
      call write9 (65,65,0.0,0.0,0.0,0.0,ki,0.,0.,0.,0.,0.,0.,0.,0.,
     1 0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.)
      write(3,694) xmi2,xma2,rme25,0.0,yma2,rme1,zmi2,zma2,rme5 
      write(3,695) 0,340,0,0,0,0,isteul,edg12
      ckm=0.6-0.3*(1.0-fudge)
c     output rest of search parameters on unit 9
      go to 2022
 671  continue
c     space groups are not chiral
      write(6,1203)
 1203 format(2x,'do you want to explore P1bar? (0=no, 1=yes)')
      read(5,*) ip1b                    
      if(ip1b.eq.0) go to 672
c     prepare things for P1bar space group only
c     iswm=0 no symmetry, =1 I symmetry
      if(iswm.ne.0.and.intern.ne.1) call err
      nspgr(1)=3
      itrsa(1)=isce
      mop(1)=2
      if(iswm.eq.0) go to 773
      write(3,694) (0.0,i=1,9)
      write(3,695) (0,i=1,7),0.0
      do 881 i=7,9
 881  ki(i)=0
      go to 774
 773  zmi=-(dmomax/2.0)-4.4+2.2*fudgf
      zma=-zmi
      xmi=-(dmomin/2.0)-4.4+2.2*fudgf
      xma=1.0
      yma=(-xmi+zma)*0.5
      ymi=-yma
      stei=0.1+0.40*fudgf
      edg1=0.15*esub*(1.0+fudge)
      write(3,694) xmi,xma,stei,ymi,yma,stei,zmi,zma,stei     
      write(3,695) (0,i=1,7),  edg1 
  774 write(6,1204)
 1204 format(2x,'any guess at p1bar cell parameters? (1 yes, 0 no)')
      read(5,*) ipcp
      if(ipcp.eq.0) go to 1205
      read(5,*) ague,bgue,cgue
      itrsa(1)=1
      ami=ague
      ama=ague+0.6
      bmi=bgue
      bma=bmi+0.6
      cmi=cgue
      cma=cmi+0.6
      staxis=0.5
      go to 1206
c     automatic set of p1bar cell parameter range
 1205 ami=4.0
      ama=1.2*dmomax+(1.0-fudgf)*dmomax
      bmi=ami
      bma=ama
      cmi=ami
      cma=ama
 1206 continue       
      i9=22
      if(iswm.ne.0) i9=0
      call write9 (i9,i9,esub,axis,ckm,ckp,ki,ami,ama,bmi,bma,cmi,cma,
     1 staxis,staxis,staxis, -90.,90.,-90.,90.,-90.,90.,
     2 stefi,stefi,stefi,-90.,90.,-90.,90.,-90.,90.,stefi,stefi,stefi)
      go to 2025
 672  continue
      write(6,1221)
 1221 format(2x,'do you want to explore C2/c (1=yes, 0=no)?')
      read(5,*) ispc2c
      if (ispc2c.eq.0) go to 677
      nspgr(3)=4
c     C2/c space group
c     first loop, A+C+I
c     set up A search
      itrsa(1)=0
      itrsa(2)=0
      itrsa(3)=isce
      write(6,1222)
 1222 format(2x,'any guess at C2/c cell parmt (1=yes,0=no)?')
      read(5,*) igc2c
      if(igc2c.ne.0) read(5,*) ague,bgue,cgue
      if(igc2c.ne.0) itrsa(3)=1 
      mop(1)=5
      kop(1)=2
      zma=dmomax*(1.0-0.8*fudgf)
      zmi=1.0
      edg1=0.2*esub+0.10*esub*fudge
      if(iswm.eq.0) go to 678
      if(intern.eq.3) call err
      if(intern.ne.2) go to 6695
      write(3,694) (0.0,i=1,8),rme5
      write(3,695) (0,i=1,7),0.0
      go to 6696
 678  write(3,694) 0.0,0.0,0.0,0.0,0.0,0.0,zmi,zma,rme5
      write(3,695) 0,340,0,340,0,160,isteul,edg1
 6696 call write9(80,80,0.0,0.0,0.0,0.0,ki,0.,0.,0.,0.,0.,0.,0.,0.,
     1 0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.)
c     set up C search
      mop(2)=7
      jop(2)=1
      kop(2)=3
      xmi=dmomin
      xma=dmomax+(0.5*dmomax*fudgf)
      ymi=xmi
      yma=xma
      if(igc2c.eq.0) go to 680
      xmi=ague/2.0
      xma=xmi+0.6
      ymi=bgue/2.0
      yma=ymi+0.6
 680  edg1=0.4*esub+0.3*esub*fudge
      write(3,694) xmi,xma,rme5,ymi,yma,rme5,0.0,0.0,0.0
      write(3,695) 0,340,0,0,0,0,isteul,edg1
      call write9(7,9,0.0,0.0,0.0,0.0,ki,0.,0.,0.,0.,0.,0.,0.,0.,
     1 0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.)
c     now set up final I search
      mop(3)=2
      zmi=1.5
      zma=dmomax/2.0+0.3*dmomax*fudgf
      xmi=0.
      xma=0.4*zma
      if(igc2c.eq.0) go to 691
      zmi=cgue/4.0
      zma=zmi+0.30
 691  write(3,694) xmi,xma,rme5,0.0,0.0,0.0,zmi,zma,rme25
      write(3,695) 0,0,0,0,0,0,0,esub
      ckm=0.5-0.3*(1.0-fudge)
      ki(4)=0
      ki(6)=0
      i8=30
      i9=36
      if(iswm.ne.0) i8=54
      if(iswm.ne.0) i9=56
      call write9(i8,i9,esub,axis,ckm,ckp,ki,0.,0.,0.,0.,0.,0.,0.,0.,
     1 0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.)
      rewind 3
      call promis (volu)
c
c     second C2/c loop, I+A+C
c
 6695 continue
      MOP(1)=2
      jop(1)=0
      kop(1)=0
      mop(2)=5
      jop(2)=0
      kop(2)=2
      mop(3)=7
      jop(3)=1
      kop(3)=3
      rewind 3
      if(iswm.eq.0) go to 733
      if(intern.ne.1) go to 4005 
      write(3,694) (0.0,i=1,9)
      write(3,695) (0,i=1,7), 0.0
      go to 734
 733  zmi=-(dmomax/2.0)-4.4+2.2*fudgf
      zma=-zmi
      xmi=-(dmomin/2.0)-4.4+2.2*fudgf
      xma=-xmi
      yma=(xma+zma)*0.5
      ymi=-yma
      stei=0.1+0.40*fudgf
      edg1=0.15*esub*(1.0+fudge)
      write(3,694) xmi,xma,stei,ymi,yma,stei,zmi,zma,stei
      write(3,695) (0,i=1,7),  edg1
 734  call write9(22,22,0.0,0.0,0.0,0.0,ki,0.,0.,0.,0.,0.,0.,0.,0.,
     1 0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.)
c     Ay search after I
      zmi2=1.0
      if(igc2c.ne.0) zmi2=cgue/4.0
      zma2=dmomax*(1.5-0.6*fudgf)
      if(igc2c.ne.0) zma2=zmi2+0.15
      edg1=0.18*esub*(1.0+fudge)       
      write(3,694) 0.,0.,0.,0.,0.,0.,zmi2,zma2,rme25
      write(3,695) 0,340,0,340,0,160,isteul,edg1
      call write9(19,21,0.0,0.0,0.0,0.0,ki,0.,0.,0.,0.,0.,0.,0.,0.,
     1 0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.)
c     final C search
      xmi=dmomin
      xma=dmomax+(0.5*dmomax*fudgf)
      ymi=xmi
      yma=xma
      if(igc2c.eq.0) go to 735
      xmi=ague/2.0
      xma=xmi+0.6
      ymi=bgue/2.0
      yma=ymi+0.6
      zmi=0.0
      zma=0.4*xma
 735  continue   
      write(3,694) xmi,xma,rme5,ymi,yma,rme5,zmi,zma,rme5
      write(3,695) 0,0,0,0,0,0,0,esub
      ckm=0.5-0.3*(1.0-fudge)
      ki(4)=0
      ki(6)=0
      i8=30
      i9=36
      if(iswm.ne.0) i8=81
      if(iswm.ne.0) i9=83
      call write9(i8,i9,esub,axis,ckm,ckp,ki,0.,0.,0.,0.,0.,0.,0.,0.,
     1 0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.)
c     end of C2/c loops
      go to 2025
c
c     P21/c operations
 677  continue
      write(6,1210)
 1210 format(2x,'do you want to explore p21/c? (1=yes,0=no)')
      read (5,*) isp21c
      if(isp21c.eq.0) go to 673
c
c     prepare for p21/c
c     three loops, I+S, S+I, G+I
c
c     check that if internal symmetry, it is I center
      if(iswm.ne.0.and.intern.ne.1) call err
      nspgr(2)=5
      ki(4)=0
      ki(6)=0
      write(6,1211)
 1211 format(2x,'any guess at p21/c cell paramt (1=yes,0=no)')
      read(5,*) igc
      if(igc.ne.0) read(5,*) ague,bgue,cgue
c
c     first loop, I+S
c
      ilop=1
      itrsa(1)=0
      itrsa(2)=isce
      mop(1)=2
      mop(2)=3
      jop(2)=2
      kop(2)=2
      if(iswm.ne.0) go to 811
      zmi1=-(dmomax/2.0)-4.4+2.2*fudgf
      zma1=-zmi1
      xmi1=-(dmomin/2.0)-4.4+2.2*fudgf
      xma1=-xmi1
      yma1=(xma1+zma1)*0.5
      ymi1=-yma1
      stei=0.1+0.40*fudgf
      edg1=0.15*esub*(1.0+fudge)      
      write(3,694) xmi1,xma1,stei,ymi1,yma1,stei,zmi1,zma1,stei     
      write(3,695) (0,i=1,7),  edg1
      go to 812
 811  write(3,694) (0.0,i=1,9)
      write(3,695) (0,i=1,7),0.0
 812  continue
      call write9 (65,65,0.0,0.0,0.0,0.0,ki,0.,0.,0.,0.,0.,0.,0.,0.,
     1 0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.)
      ymi2=dmomin*0.5
      if(igc.ne.0) ymi2=bgue*0.5
      yma2=dmomax*(1.2-0.4*fudgf)
      if(igc.ne.0) yma2=ymi2+0.6
      zmi2=1.0
      if(igc.ne.0) zmi2=cgue/4.0
      zma2=dmomax*(1.2-0.8*fudgf)
      if(igc.ne.0) zma2=zmi2+0.30
      edg1=0.6*esub+0.45*esub*fudge
      ami=4.
      if(igc.ne.0) ami=ague
      ama=dmomax*(2.7-0.9*fudgf)
      if(igc.ne.0) ama=ami+1.2
      write(3,694) 0.,0.,0.,ymi2,yma2,rme5,zmi2,zma2,rme25    
      write(3,695) 0,340,0,340,0,160,isteul,edg1
      i8=10
      i9=12
      if(iswm.ne.0) i8=65
      if(iswm.ne.0) i9=65
      call write9 (i8,i9,esub,axis,ckm,ckp,ki,ami,ama,0.,0.,0.,0.,             
     1 staxis,0.,0., 0.,0.,0.,0.,0.,0.,0.,0.,0.,        
     2 -90.,90.,0.,0.,0.,0.,stefi,0.,0.)
      if(igc.eq.0) go to 681
c     P21/c only, input cell parameters
      rewind 3
      call promis (volu)
      go to 4001
 681  continue
       write(6,1301)
 1301 format(2x,'do you want to explore Pbca (1=yes,0=no)')
      read(5,*) ipbca
      if (ipbca.ne.0) go to 682
c     P21/c only
      rewind 3
      call promis (volu)
      go to 4001
 682  continue
c     Pbca after P21/c
      nspgr(3)=6
      ki(5)=0
      mop(3)=4
      jop(3)=1
      kop(3)=3
      itrsa(3)=isce
      xmi=dmomin/2.0
      xma=2.0*dmomax-0.5*dmomax*fudgf
      ckm=0.5-0.3*(1.0-fudge)
      write(3,694) xmi,xma,rme5,0.,0.,0.,0.,0.,0.
      write(3,695) (0,i=1,7),esub
      call write9(23,29,esub,axis,ckm,ckp,ki,0.,0.,0.,0.,0.,0.,0.,0.,
     1 0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.)
      rewind 3
      call promis (volu)
      go to (4001,4002,4005),ilop
c     Pbca alone, I+S+G
673   itrsa(3)=isce
c     check that if internal symmetry, it is I center
      if(iswm.ne.0.and.intern.ne.1) call err
      nspgr(3)=6
      mop(1)=2
      mop(2)=3
      jop(2)=2
      kop(2)=2
      mop(3)=4
      jop(3)=1
      kop(3)=3
      write(6,1302)
 1302 format(2x,'any guess at Pbca cell parmt.(1=yes,0=no)')
      read (5,*) igp
      if (igp.ne.0) read (5,*) aguf,bguf,cguf
      if(igp.ne.0) itrsa(3)=1
      if(iswm.ne.0) go to 813
      zmi1=-(dmomax/2.0)-4.4+2.2*fudgf
      zma1=-zmi1
      xmi1=-(dmomin/2.0)-4.4+2.2*fudgf
      xma1=-xmi1
      yma1=(xma1+zma1)*0.5
      ymi1=-yma1
      stei=0.1+0.40*fudgf
      edg1=0.15*esub*(1.0+fudge)     
      write(3,694) xmi1,xma1,stei,ymi1,yma1,stei,zmi1,zma1,stei     
      write(3,695) (0,i=1,7), edg1
      go to 814
 813  write(3,694) (0.0,i=1,9)
      write(3,695) (0,i=1,7),0.0
 814  continue
      call write9 (65,65,0.0,0.0,0.0,0.0,ki,0.,0.,0.,0.,0.,0.,0.,0.,
     1 0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.)
      ymi2=dmomin*0.5
      if(igp.ne.0) ymi2=bguf*0.5
      yma2=dmomax*(1.2-0.4*fudgf)
      if(igp.ne.0) yma2=ymi2+0.6
      zmi2=1.0
      if(igp.ne.0) zmi2=cguf/4.0
      zma2=dmomax*(1.2-0.8*fudgf)
      if(igp.ne.0) zma2=zmi2+0.30
      edg1=0.6*esub+0.45*esub*fudge
      write(3,694) 0.,0.,0.,ymi2,yma2,rme5,zmi2,zma2,rme1    
      write(3,695) 0,340,0,340,0,160,isteul,edg1
      call write9 (10,12,0.00,0.00,0.0,0.0,ki,0.,0.,0.,0.,0.,0.,0.,0.,
     1 0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.)
      xmi=dmomin/2.0
      if(igp.ne.0) xmi=aguf*0.5
      xma=2.0*dmomax-0.5*dmomax*fudgf
      if(igp.ne.0) xma=xmi+rme5
      ckm=0.5-0.3*(1.0-fudge)
      ki(4)=0
      ki(5)=0
      ki(6)=0
      write(3,694) xmi,xma,rme5,0.,0.,0.,0.,0.,0.
      write(3,695) (0,i=1,7),esub
      i8=23
      i9=29
      if(iswm.ne.0) i8=69
      if(iswm.ne.0) i9=71
      call write9(i8,i9,esub,axis,ckm,ckp,ki,0.,0.,0.,0.,0.,0.,0.,0.,
     1 0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.)
      rewind 3
      call promis (volu)
c
c     second P21/c loop, S+I
c
 4001 continue
c     if internal symmetry skip further loops
      if(iswm.ne.0) go to 4005
      ilop=2
      rewind 3
      do 4003 i=1,3
      itrsa(i)=0
      mop(i)=0
      jop(i)=0
 4003 kop(i)=0
      if(isp21c.eq.0) go to 6673
      itrsa(2)=isce
      if(igc.ne.0) itrsa(2)=1
c     P21/c part
      nspgr(2)=5
      ki(5)=1
      mop(2)=2
      mop(1)=3
      jop(1)=2
      kop(1)=2
      ymi1=ymsy
      if(ymi1.lt.0.01) ymi1=dmomin*0.3
      if(ymi1.lt.2.0) ymi1=2.0
      if(igc.ne.0) ymi1=bgue*0.5
      yma1=dmomax*(1.0-0.4*fudgf)
      if(igc.ne.0) yma1=ymi1+0.6
      zma1=dmomax*(1.0-0.7*fudgf)
      edg1=0.4*esub+0.30*esub*fudge
      write(3,694) 0.,0.,0.,ymi1,yma1,rme5,1.0,zma1,rme1     
      write(3,695) 0,340,0,340,0,160,isteul,edg1
      call write9 (65,65,0.0,0.0,0.0,0.0,ki,0.,0.,0.,0.,0.,0.,0.,0.,
     1 0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.)
      zma2=dmomax-0.3*dmomax*fudgf
      zmi2=0.3*dmomin
      if(igc.ne.0) zmi2=cgue/4.0
      if(igc.ne.0) zma2=zmi2+0.30
      edg1=0.60*esub+0.45*esub*fudge
      write(3,694) 0.0,0.0,0.0,0.0,0.0,0.0,zmi2,zma2,rme25
      write(3,695) 0,340,0,0,0,0,isteul,edg1
      ami=4.0
      ama=dmomax*2.7-0.9*fudgf*dmomax
      if(igc.ne.0) ami=ague
      if(igc.ne.0) ama=ami+1.2
      call write9 (10,12,esub,axis,ckm,ckp,ki,ami,ama,0.0,0.0,0.0,0.0,
     1 staxis,0.0,0.0,0.,0.,0.0,0.0,0.0,0.0,0.0,0.0,0.0,
     2 -90.,90.,0.0,0.0,0.0,0.0,stefi,0.0,0.0)
      if(igc.eq.0) go to 6681
      rewind 3
      call promis (volu)
      go to 4002
 6681  continue
      if (ipbca.ne.0) go to 682
      rewind 3
      call promis (volu)
      go to 4002
c     Pbca alone, second loop S+I+G
 6673 itrsa(3)=isce
      if(igp.ne.0) itrsa(3)=1
      nspgr(3)=6
      ki(5)=0
      mop(2)=2
      mop(1)=3
      jop(1)=2
      kop(1)=2
      mop(3)=4
      jop(3)=1
      kop(3)=3
      ymi1=ymsy
      if(ymi1.lt.0.01) ymi1=dmomin*0.3
      if(ymi1.lt.2.0) ymi1=2.0
      if(igp.ne.0) ymi1=bguf*0.5
      yma1=dmomax*(1.0-0.4*fudgf)
      if(igp.ne.0) yma1=ymi1+0.6
      zma1=dmomax*(1.0-0.7*fudgf)
      edg1=0.4*esub+0.30*esub*fudge
      write(3,694) 0.,0.,0.,ymi1,yma1,rme5,1.0,zma1,rme1    
      write(3,695) 0,340,0,340,0,160,isteul,edg1
      call write9 (65,65,0.00,0.00,0.0,0.0,ki,0.,0.,0.,0.,0.,0.,0.,0.,
     1 0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.)
      zmi2=0.3*dmomin
      zma2=dmomax-0.3*dmomax*fudgf
      if(igp.ne.0) zmi2=cguf/4.0
      if(igp.ne.0) zma2=zmi2+0.30
      edg1=0.6*esub+0.45*esub*fudge
      write(3,694) (0.0,i=1,6),zmi2,zma2,rme25
      write(3,695) 0,340,0,0,0,0,isteul,edg1
      call write9 (10,12,0.0,0.0,0.0,0.0,ki,0.,0.,0.,0.,0.,0.,0.,0.,
     1 0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.)
      xmi=dmomin/2.0
      if(igp.ne.0) xmi=aguf*0.25
      xma=2.0*dmomax-0.5*dmomax*fudgf
      if(igp.ne.0) xma=xmi+rme25
      ckm=0.5-0.3*(1.0-fudge)
      ki(4)=0
      ki(5)=0
      ki(6)=0
      write(3,694) xmi,xma,rme5,0.,0.,0.,0.,0.,0.
      write(3,695) (0,i=1,7),esub
      call write9(23,29,esub,axis,ckm,ckp,ki,0.,0.,0.,0.,0.,0.,0.,0.,
     1 0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.)
      rewind 3
      call promis (volu)
c
c     third P21/c loops, G+I
c
 4002 continue
c     this check should be redundant
      if(iswm.ne.0) go to 4005
      ilop=3
      rewind 3
      do 4004 i=1,3
      itrsa(i)=0
      mop(i)=0
      jop(i)=0
 4004 kop(i)=0
      if(isp21c.eq.0) go to 6773
c     P21/c part
      nspgr(2)=5
      itrsa(1)=0
      itrsa(2)=isce
      if(igc.ne.0) itrsa(2)=1
      ki(5)=1
      mop(2)=2
      mop(1)=4
      jop(1)=3
      kop(1)=2
      yma1=dmomax*(1.0-0.7*fudgf)
      zmi1=ymsy
      if(zmi1.lt.0.01) zmi1=dmomin*0.3
      if(zmi1.lt.2.0) zmi1=2.0
      if(igc.ne.0) zmi1=cgue/2.0
      zma1=dmomax*(1.0-0.4*fudgf)
      if(igc.ne.0) zma1=zmi1+0.6
      edg1=0.3*esub+0.20*esub*fudge
      write(3,694) 0.,0.,0.,1.0,yma1,rme1,zmi1,zma1,rme5    
      write(3,695) 0,340,0,340,0,160,isteul,edg1
      call write9 (78,78,0.00,0.00,0.0,0.0,ki,0.,0.,0.,0.,0.,0.,0.,0.,
     1 0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.)
      ymi2=1.0
      if(igc.ne.0) ymi2=bgue/4.0
      yma2=dmomax*(1.2-0.5*fudgf)
      if(igc.ne.0) yma2=ymi2+0.13
      stei=0.5+0.35*fudgf
      stey=0.15+0.2*fudgf
      if(igc.ne.0) stey=0.125
      edg1=0.60*esub+0.45*esub*fudge
      write(3,694)  0.0,5.0,stei,ymi2,yma2,stey,0.0,3.0,stei
      write(3,695) (0,i=1,7),  edg1
      ami=4.0
      ama=dmomax*2.7-0.9*fudgf*dmomax
      da=staxis
      if(igc.ne.0) da=0.5
      if(igc.ne.0) ami=ague
      if(igc.ne.0) ama=ami+0.6
      call write9 (10,12,esub,axis,ckm,ckp,ki,ami,ama,0.,0.,0.,0.,
     1 da,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,-90.,90.,0.,0.,0.,0.,
     2 stefi,0.,0.)
c     closing P21/c-Pbca loops
      if(igc.eq.0) go to 6781
      go to 2025
 6781  continue
      if (ipbca.ne.0) go to 682
      go to 2025
c     Pbca alone, third loop G+I+S
 6773 itrsa(3)=isce
      nspgr(3)=6
      if(igp.ne.0) itrsa(3)=1
      ki(5)=0
      mop(2)=2
      mop(1)=4
      jop(1)=3
      kop(1)=2
      mop(3)=4
      jop(3)=1
      kop(3)=3
      yma1=dmomax*(1.0-0.7*fudgf)
      zmi1=ymsy
      if(zmi1.lt.0.01) zmi1=dmomin*0.3
      if(zmi1.lt.2.0) zmi1=2.0
      if(igc.ne.0) zmi1=cgue/2.0
      zma1=dmomax*(1.0-0.4*fudgf)
      if(igc.ne.0) zma1=zmi1+0.6
      edg1=0.3*esub+0.20*esub*fudge
      write(3,694) 0.,0.,0.,1.0,yma1,rme1,zmi1,zma1,rme5    
      write(3,695) 0,340,0,340,0,160,isteul,edg1
      call write9 (78,78,0.00,0.00,0.0,0.0,ki,0.,0.,0.,0.,0.,0.,0.,0.,
     1 0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.)
      ymi2=1.0
      if(igc.ne.0) ymi2=bgue/4.0
      yma2=dmomax*(1.2-0.5*fudgf)
      if(igc.ne.0) yma2=ymi2+0.13
      stei=0.5+0.35*fudgf
      stey=0.15+0.2*fudgf
      if(igc.ne.0) stey=0.125
      edg1=0.60*esub+0.45*esub*fudge
      write(3,694) 0.0,5.0,stei,ymi2,yma2,stey,0.0,3.0,stei
      write(3,695) (0,i=1,7),  edg1
      call write9 (10,12,0.0,0.0,0.0,0.0,ki,0.,0.,0.,0.,0.,0.,0.,0.,
     1 0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.)
      xmi=dmomin/2.0
      if(igp.ne.0) xmi=aguf*0.5
      xma=2.0*dmomax-0.5*dmomax*fudgf
      if(igp.ne.0) xma=xmi+rme5
      ckm=0.5-0.3*(1.0-fudge)
      write(3,694) xmi,xma,rme5,0.,0.,0.,0.,0.,0.
      write(3,695) (0,i=1,7),esub
      call write9(23,29,esub,axis,ckm,ckp,ki,0.,0.,0.,0.,0.,0.,0.,0.,
     1 0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.)
c     normal end of all preparatory loops
c     call promis subroutine and search nuclei and structures
 2025 rewind 3
      CALL PROMIS(VOLU)
c     having finished operations, sort structures found
 4005 call sorter   
      END
      SUBROUTINE PROMIS (VOLU)    
      DIMENSION TBEST(2,3,3,2000),LTZ(2,2000),LFZ(2,2000),LCZ(2,2000)
      DIMENSION SSX(10,120,3),IPREV(2000)
      dimension ebf(200),xbf(200,3),iseq(200),xcall(3)
      double precision grla(6)
      COMMON/NUMNU/KLP,JLP
      COMMON/ORIG/MOP(3),JOP(3),KOP(3),ITRS(3),TFIRST(3,3),ITRSA(3)
      COMMON /VARIA/ AX5,NMOL,CUT2,ESUB,FD1,FD2,FD3,FD4, NTOP,IWAR(3)
      COMMON /LRS/ BRUF(120,3)
      COMMON /SMAT/ ROG(3,3),TOG(3)   
      COMMON/OPEC1/ALFA(7000,3),RM(800,3,3),QRG(120),NPE
      COMMON/OPEC2/ PESO(120),CUTOFF,ILEVEL(5),ISPEN(120),TIPO(15,15,3),
     1 NATOM,NA,NAA,NB,NC,ND,NE,NF,NG,NH,NI,NL,NM,NEE,NEM,NEF,NEL,NEP,
     2 NDD,NDE,NDF,NDG,NDH
      COMMON /RESU/ XBR(3),ine(100,100),XOPT(2,3,2000),
     1 T(3,3),TRA(3),EMX(2,2000),MTOP(3),TCOR(3,3)
      COMMON /BOXD/ X(8,120,3),SX(8,120,3)                            
      COMMON/XEN/TABEN(8,8,700),CT(361),ST(361)
      COMMON/MEMO/XBG(3),LT,LF,LC,RR1,RR2,RR3,PHI1,PHI2,PHI3,
     1 TETA1,TETA2,TETA3
      COMMON/SY/ISWM,nspgr(3)
      COMMON/HALF/HALF,nsomax
      data grla/'P21','P212121','P1-','C2/c','P21/c','Pbca'/
C     NABLE IS THE MAX DIMENSION OF THE ENERGY MAP
C     IBEST IS THE MAX NUMBER OF NUCLEI SAVED FOR THE NEXT OPERATION
c     nustr labels structures found
      nustr=0
      KLP=0
      JLP=0
      IBEST=2000
      NABLE=100
      PZ=0.0174533
C     TAKE COORDINATES OF MODEL MOLECULE  AS MOL.COORDS. IN LRS
      DO 1 I=1,NATOM
      DO 1 J=1,3
      X(1,I,J)=BRUF(I,J)
  1   SSX(1,I,J)=BRUF(I,J)
 53   FORMAT(F10.0)
      DO 832 K=1,3
      DO 832 I=1,3
 832  TCOR(K,I)=0.0
      do 833 k=1,2
      do 833 i=1,3
      DO 833 J=1,3
      DO 833 L=1,IBEST
 833  TBEST(K,I,J,L)=0.0
      MOLD=MOP(1)
C     OPEN MAIN LOOP ON SYMMETRY OPERATIONS
      DO 777 NOP=1,3
      MTOP(NOP)=0
      ISTOR=0
      MPN=MOP(NOP)
      IF(MPN.EQ.0) GO TO 700
      nss=nspgr(nop)
      if(nss.ne.0) write(8,8) grla(nss)
 8    format(/2x,'Going to space group',2x,a8)
      DO 1503 I=1,3
 1503 ITRS(I)=1
C     NMOL IS THE NUMBER OF MOLECULES BEFORE NUCLEUS OPERATION
      NMOL=2**(NOP-1)
      NTOP=2*NMOL
      JPN=JOP(NOP)
      KPN=KOP(NOP)
      DO 263 I=1,nable
      DO 263 J=1,nable
 263  INE(I,J)=0
      DO 363 I=1,NMOL
      DO 363 J=1,NATOM
      DO 363 K=1,3
 363  SX(I,J,K)=SSX(I,J,K)
      WRITE(8,224) NOP,MPN,JPN,KPN
 224  FORMAT(2X,'OPERATION NO.',I3,2X,'CURRENT INDICATORS',3I4)
c     space limits of promis search
      READ(3,*) XL,XU,STPX,YL,YU,STPY,ZL,ZU,STPZ
      NUMX=1
      NUMY=1
      NUMZ=1
      IF(STPX.LT.0.0001) GO TO 446
      NUMX=(XU-XL)/STPX+1
 446  IF(STPY.LT.0.0001) GO TO 447
      NUMY=(YU-YL)/STPY+1
 447  IF(STPZ.LT.0.0001) GO TO 448
      NUMZ=(ZU-ZL)/STPZ+1
 448  CONTINUE
C     THIS CARD CONTROLS MOLECULAR ROTATIONS 
      READ(3,*) IT1,IT2,IF1,IF2,IC1,IC2,ISPR,EDGAS      
c     retrieve symmetry operations from unit 3
      read(3,*) npe
      if(npe.eq.0) go to 994
      do 991 i=1,npe
      ip=i+1
      ko=nh+ip
      read(3,992) ((rm(ip,k,l),l=1,3),k=1,3),(alfa(ko,m),m=1,3)
 991  continue
 992  format(9f7.1,3f9.3)
 994  npe=npe+1
      call retra
      IF(ISPR.EQ.0) ISPR=1
C     ADJUST ANGULAR INDICES TO SINE AND COSINE TABLE
      IT1=IT1+1
      IT2=IT2+1
      IF1=IF1+1
      IF2=IF2+1
      IC1=IC1+1
      IC2=IC2+1
C     SKIP SEARCH SUBROUTINES IF IDENTITY
      IF(MPN.NE.1) GO TO 201
C     PREPARE DATA FOR P1
      EMX(1,1)=0.0   
      DO 103 I=1,3
      IWAR(I)=0
 103  XOPT(1,I,1)=0.0
      ILAY=1
      NTOP=1
      CALL TRAS(VOLU,EMX(1,1),0.0,1,TCOR,nustr)
      RETURN   
 201  WRITE(8,61) XL,XU,STPX,YL,YU,STPY,ZL,ZU,STPZ
 61   FORMAT(2X,'Linear scan ranges',
     1 /1X,3(3F7.2))           
      IF(STPX.EQ.0.0) ITRS(1)=0
      IF(STPY.EQ.0.0) ITRS(2)=0
      IF(STPZ.EQ.0.0) ITRS(3)=0
      WRITE(8,441) IT1,IT2,IF1,IF2,IC1,IC2,ISPR,EDGAS      
 441  FORMAT(2X,'Theta,fi,chi ranges',6I5,1X,'Step',I4,2x,'Emin',f8.2)
      GO TO (751,752,752),NOP
C     SECOND OPERATION
C     START LOOP OVER NUCLEI FROM FIRST OPERATION
  752 CONTINUE
      KLP=0
      KLMAX=MTOP(1)
  754 KLP=KLP+1
      DO 2363 J=1,NATOM
      DO 2363 K=1,3
 2363 SX(1,J,K)=SSX(1,J,K)
      IF(KLP.GT.KLMAX) GO TO 755
      DO 1501 I=1,3
      XBR(I)=XOPT(1,I,KLP)
      DO 1501 J=1,3
 1501 TFIRST(I,J)=TBEST(1,I,J,KLP)
      WRITE(8,2364) KLP, LTZ(1,KLP),LFZ(1,KLP),LCZ(1,KLP),XBR,
     1 ((TFIRST(LU,MU),MU=1,3),LU=1,3)
 2364 FORMAT(1X,'Cluster N.',I4,1X,'From first operation, paramt',
     1 /3I4,2X,3F5.1,1X,9F5.1)
      CALL EULER(LTZ(1,KLP),LFZ(1,KLP),LCZ(1,KLP),1)
C     SAVE ACTUAL VALUE OF NMOL, SET NMOL AS APPROPRIATE
C     FOR CALLING SYMNU IN ORIGIN
      NTEMP=NMOL
      NMOL=1
      CALL ORIGIN(1,MOP(1),JOP(1),KOP(1),NATOM,XBR,0)   
      NMOL=NTEMP
      DO 1363 I=1,2
      DO 1363 J=1,NATOM
      DO 1363 K=1,3
 1363 SX(I,J,K)=X(I,J,K)
      IF(NOP.LT.3) GO TO 751
C     THIRD OPERATION
C     START LOOP OVER NUCLEI FROM SECOND OPERATION
      JLP=0
      JLMAX=MTOP(2)
 1754 JLP=JLP+1
C     SKIP IF FIRST NUCLEUS DOES NOT CORRESPOND TO SECOND
      IF(JLP.GT.JLMAX) GO TO 754
      IF(KLP.NE.IPREV(JLP)) GO TO 1754
      DO 1756 I=1,3
      XBR(I)=XOPT(2,I,JLP)
      DO 1756 J=1,3
 1756 TFIRST(I,J)=TBEST(2,I,J,JLP)
      WRITE(8,2365) JLP, LTZ(2,JLP),LFZ(2,JLP),LCZ(2,JLP),XBR,
     1 ((TFIRST(LU,MU),MU=1,3),LU=1,3)
 2365 FORMAT(1X,'Cluster N.',I4,1X,'From second operation, parmt',
     1 /3I4,2X,3F5.1,1X,9F5.1)
      CALL EULER(LTZ(2,JLP),LFZ(2,JLP),LCZ(2,JLP),2)
      NTEMP=NMOL
      NMOL=2
      CALL ORIGIN(2,MOP(2),JOP(2),KOP(2),NATOM,XBR,MOP(1))
      NMOL=NTEMP
      DO 1757 I=1,4
      DO 1757 J=1,NATOM
      DO 1757 K=1,3
 1757 SX(I,J,K)=X(I,J,K)
  751 CONTINUE
      DO 835 I=1,3
 835  IWAR(I)=0
      DO 836 I=1,IBEST
      if(nop.eq.3) go to 836
      EMX(NOP,I)=0.0
 836  continue
      IF(NUMY.GT.NABLE.OR.NUMZ.GT.NABLE) GO TO 999
      DO 443 IIX=1,NUMX
      XBR(1)=XL+FLOAT(IIX-1)*STPX
      XBG(1)=XBR(1)
      DO 4 IIY=1,NUMY
      XBR(2)=YL+FLOAT(IIY-1)*STPY
      XBG(2)=XBR(2)
c     in P212121 skip some y search 2nd operation
      if(nop.ne.2.or.nspgr(2).ne.2) go to 7
      xe=xopt(1,2,klp)*1.5
      if(xbr(2).gt.xe) go to 4
 7    continue  
      DO 444 IIZ=1,NUMZ
      XBR(3)=ZL+FLOAT(IIZ-1)*STPZ
      XBG(3)=XBR(3)
      INE(IIY,IIZ)=0
C     OPEN LOOPS FOR MOLECULAR ROTATION
 312  ELD=0.0
      ELD12=0.0
      DO 4011 LT=IT1,IT2,ISPR
      DO 4012 LF=IF1,IF2,ISPR
C     TRY TO REMOVE DEGENERACY IN EULER ROTATIONS IF TETA=0
      IZERF=IC1
      IF(LT.NE.1) GO TO 399
      IF(LF.GT.IC2) GO TO 4012
      IZERF=LF
 399  DO 4013 LC=IZERF,IC2,ISPR
      CALL EULER(LT,LF,LC ,NMOL) 
      CALL SYMNU (NATOM,MPN,JPN,KPN,XBR)
C     SELECT OPERATION NUMBER
      GO TO (701,702,703), NOP
C     THIS IS THE SECTION FOR THE FIRST OPERATION
 701  CONTINUE
      ILAY=1
      ED=0.0
      E12=0.0
      DO 644 I=1,3
      IWAR(I)=0
      DO 644 J=1,3
 644  T(I,J)=0.0
      CALL PACKT(ED) 
      E12=ED
C     ILAY IS THE STRUCTURE STATUS INDICATOR
C     =1 NUCLEUS, =2 STRING, =3 LAYER, =4 3D STRUCTURE
      IF(JPN.EQ.0) GO TO 12 
      IF(MPN.EQ.7) GO TO 721
      ILAY=2
      T(JPN,JPN)=2.0*XBR(JPN)
      IWAR(JPN)=1
       GO TO 138    
 721  ILAY=3
 724  T(1,1)=XBR(1)*2.0
      T(2,2)=XBR(2)*2.0
      T(1,3)=XBR(3)*2.0
      IWAR(1)=1
      IWAR(2)=1
 725  CONTINUE
      GO TO 138      
C     THIS IS THE SECTION FOR THE SECOND OPERATION
 702  MOLD=MOP(1)
      DO 120 I=1,3
      IWAR(I)=0 
      DO 120 J=1,3
 120  T(I,J)=0.0
      CALL PACKT(ED)
      E12=ED
      ILAY=1
      DO 121 I=1,3
      DO 121 J=1,3
      IF(TFIRST(I,J).NE.0) IWAR(I)=1
 121  T(I,J)=TFIRST(I,J)
      GO TO (999,122,123,124,125,126,999), MOLD
 122  GO TO (999,998,133,134,135,136,998), MPN
 133  IF(KPN.NE.2.OR.ITRS(1).EQ.1) GO TO 998
      IF(ITRS(3).EQ.0) GO TO 137
      T(2,2)=2.0*XBR(2)
      T(3,3)=4.0*XBR(3)
 148  IWAR(2)=1
      IWAR(3)=1
      ILAY=3
      GO TO 138
 137  T(2,2)=2.0*XBR(2)
      IWAR(2)=1
      ILAY=2
      GO TO 138
 134  IF(JPN.NE.3.OR.KPN.NE.2) GO TO 998
      IF(ITRS(1).EQ.1) GO TO 999
      T(2,2)=4.0*XBR(2)
      T(3,3)=2.0*XBR(3)
      GO TO 148
 135  IF(KPN.NE.2.OR.ITRS(1).EQ.1.OR.ITRS(2).EQ.1) GO TO 998
      ILAY=1
      IF(ITRS(3).EQ.0) GO TO 12 
      IWAR(3)=1
      T(3,3)=4.0*XBR(3)
      ILAY=2
      GO TO 138
 136  IF(KPN.NE.2.OR.ITRS(1).EQ.1.OR.ITRS(3).EQ.1) GO TO 998
      ILAY=1
      IF(ITRS(2).EQ.0) GO TO 12 
      T(2,2)=4.0*XBR(2)
      IWAR(2)=1
      ILAY=2
      GO TO 138
 123  GO TO (999,142,143,144,145,998,998), MPN
 142  IF(JOP(1).NE.2.OR.ITRS(1).EQ.1) GO TO 998
      T(3,3)=4.0*XBR(3)
      IWAR(3)=1
      ILAY=3
      GO TO 138
 143  IF(JOP(1).NE.2) GO TO 998
      IWAR(1)=1
      IF(ITRS(3).EQ.0) GO TO 146
      IF(JPN.NE.3) GO TO 998
      ILAY=4
      T(1,1)=4.0*XBR(1)
      T(3,3)=2.0*XBR(3)
      IWAR(3)=1
      GO TO 138
 146  IF(JPN.NE.1) GO TO 998
      T(1,1)=2.0*XBR(1)
      ILAY=3
      GO TO 138
 144  IF(JPN.EQ.3.AND.KPN.EQ.2) GO TO 1441
      IF(JPN.EQ.1.AND.KPN.EQ.2) GO TO 1442
      IF(JPN.EQ.3.AND.KPN.EQ.1) GO TO 1443
      GO TO 998
 1441 IF(ITRS(1).EQ.1.OR.JOP(1).NE.2) GO TO 998
      T(3,3)=2.0*XBR(3)
      IWAR(3)=1
      ILAY=3
      GO TO 138
 1442 IF(ITRS(3).EQ.1.OR.JOP(1).NE.3) GO TO 998
      T(1,1)=2.0*XBR(1)
      IWAR(1)=1
      ILAY=3
      IF(ITRS(2).EQ.0) GO TO 138
      T(2,2)=4.0*XBR(2)
      IWAR(2)=1
      ILAY=4
      GO TO 138
 1443 IF(ITRS(2).EQ.1.OR.JOP(1).NE.3) GO TO 998
      TEA=0.5*TFIRST(3,3)
      IF(XBR(3).NE.TEA) GO TO 998
      T(1,1)=4.0*XBR(1)
      IWAR(1)=1
      ILAY=3
      GO TO 138
 145  IF(ITRS(3).EQ.1.OR.KPN.NE.3.OR.JOP(1).NE.2) GO TO 998
      T(1,1)=4.0*XBR(1)
      IWAR(1)=1
      ILAY=3
      GO TO 138
 124  GO TO (999,152,153,154,998,998,157),MPN
 152  IF(JOP(1).NE.3.OR.KOP(1).NE.2) GO TO 998
      T(2,2)=4.0*XBR(2)
      IWAR(2)=1
      ILAY=3
      GO TO 138
 153  IF(KOP(1).NE.2) GO TO 998
      JJ1=JOP(1)
      GO TO (158,998,155),JJ1
 158  IF(JPN.NE.3) GO TO 998
      T(3,3)=2.0*XBR(3)
      IWAR(3)=1
      IF(ITRS(2).EQ.1) GO TO 156
      ILAY=3
      GO TO 138
 156  T(2,2)=4.0*XBR(2)
      ILAY=4
      IWAR(2)=1
      GO TO 138
 155  IF(JPN.NE.2) GO TO 998
      T(2,2)=2.0*XBR(2)
      IWAR(2)=1
      ILAY=3
      GO TO 138
 154  IF(JOP(1).NE.3.OR.KOP(1).NE.2.OR.JPN.NE.1.OR.KPN.NE.3) GO TO 998
      IF(ITRS(2).EQ.1) GO TO 999
      T(1,1)=2.0*XBR(1)
      IWAR(1)=1
      ILAY=3
      GO TO 138
 157  IF(JOP(1).NE.3.OR.KOP(1).NE.2) GO TO 998
 162  T(1,1)=2.0*XBR(1)
      T(1,3)=2.0*XBR(3)
      T(2,2)=2.0*XBR(2)
      IWAR(1)=1
      IWAR(2)=1
      ILAY=4
      IF((MOP(1).EQ.5).OR.(MOP(1).EQ.6)) ILAY=3
      GO TO 138
 125  GO TO (999,602,999,999,999,999,607),MPN
 602  IF(KOP(1).NE.2) GO TO 998
      IF(ITRS(1).EQ.1) GO TO 998
      T(3,3)=4.0*XBR(3)
      IWAR(3)=1
      ILAY=2
      GO TO 138
 607  CONTINUE
      IF(KOP(1).NE.2) GO TO 998
      GO TO 162
 126  GO TO (999,612,999,999,999,999,617), MPN
 612  IF(KOP(1).NE.2) GO TO 998
      T(2,2)=4.0*XBR(2)
      IWAR(2)=1
      ILAY=2
      GO TO 138
 617  CONTINUE
      IF(KOP(1).NE.2) GO TO 998
      GO TO 162
 998  ISTAN=1
      GO TO 12 
 703  CONTINUE
      DO 500 I=1,3
      IWAR(I)=0 
      DO 500 J=1,3
 500  T(I,J)=0.0
      CALL PACKT(ED)
      E12=ED
      ILAY=1
      DO 510 I=1,3
      DO 510 J=1,3
      IF(TFIRST(I,J).NE.0) IWAR(I)=1
 510  T(I,J)=TFIRST(I,J)
      MOLD=MOP(1)
      MOLE=MOP(2)
      GO TO (599,502,503,504,505,506,599),MOLD
 502  GO TO (599,599,513,514,515,599,599),MOLE
 515  GO TO (599,599,599,599,599,599,527),MPN   
 527  T(2,2)=2.0*XBR(2)
      T(1,1)=2.0*XBR(1)
      T(1,3)=2.0*XBR(3)
      IWAR(1)=1
      IWAR(2)=1
      ILAY=4
      GO TO 138
 505  GO TO (599,599,599,599,599,599,537), MOLE
 537  GO TO (599,542,599,599,599,599,599), MPN
 542  T(3,1)=4.0*XBR(1)
      T(3,3)=4.0*XBR(3)
      IWAR(3)=1
      ILAY=4
      GO TO 138
 513  GO TO (599,599,543,544,599,599,599), MPN
 514  GO TO (599,599,543,544,599,599,599), MPN
 503  GO TO (599,552,599,554,599,599,599), MOLE
 552  GO TO (599,599,543,544,599,599,599), MPN
 554  GO TO (599,599,543,544,599,599,599), MPN
 504  GO TO (599,562,563,599,599,599,599), MOLE
 562  GO TO (599,599,543,544,599,599,599), MPN
 563  GO TO (599,599,543,544,599,599,599), MPN
 543  GO TO (571,599,573), JPN
 571  XBR(3)=0.0
      XBR(2)=T(2,2)*0.25
      T(1,1)=2.0*XBR(1)
      GO TO 1388
 573  IF(ITRS(3).EQ.1) GO TO 5773
      XBR(2)=0.0
      XBR(3)=0.5*T(3,3)
      T(1,1)=4.0*XBR(1)
      GO TO 1388
 5773 GO TO 5774
 544  GO TO (581,582,599), JPN
 581  XBR(2)=0.0
      XBR(3)=0.25*T(3,3)
      T(1,1)=2.0*XBR(1)
      GO TO 1388
 582  XBR(3)=0.0
      XBR(2)=0.5*T(2,2)
      T(1,1)=4.0*XBR(1)
 1388 IWAR(1)=1
      ILAY=4
      CALL SYMNU(NATOM,MPN,JPN,KPN,XBR)
      GO TO 138
 506  GO TO (599,592,599,599,599,599,599), MOLE
 592  GO TO (599,599,5993,599,599,599,599) MPN
 5993 IF(KPN.NE.3) GO TO 998
 5774 IF(ITRS(2).EQ.1) GO TO 998
      T(1,1)=4.0*XBR(1)
      T(3,3)=2.0*XBR(3)
      IWAR(1)=1
      IWAR(3)=1
      ILAY=4
      GO TO 138
 599  CALL ERR
      STOP
c     ----------------------------------
C     MOLECULE-MOLECULE, STRING OR LAYER ENERGY IS COMPUTED
c     ----------------------------------
 138  CALL PACKT(ED)
  12  CONTINUE                                 
      IF(ED.GT.EDGAS) GO TO 727
      ISTOR=ISTOR+1
      ded=ed-edgas
      dis=0.2*edgas
      if(dis.le.ded) go to 291
      edgas=edgas+0.1*(ded-dis)
      write(8,292) edgas
 292  format(20x,'resetting Emin',f10.2)
 291  if(ilevel(2).ne.0)
     1 WRITE(8,381) ISTOR,ED,XBR(1),XBR(2),XBR(3),LT,LF,LC
 381  FORMAT(1X,'cluster no.',I4,' with E',F8.2,2X,'at',3F6.2,3I4)
      DO 8282 IL=1,3
      ONE=1.0
      IF(T(IL,IL).LT.0.0) ONE=-1.0
      DO 8282 JL=1,3
 8282 TCOR(IL,JL)=ONE*T(IL,JL)
      IF(NOP.EQ.3) GO TO 1010
      if(nop.eq.1.and.mpn.eq.2) go to 811
      NOP1X=NOP+1
      IF(MOP(NOP1X).EQ.0) GO TO 1010
 811  IF(ISTOR.GT.IBEST) GO TO 8383
      EMX(NOP,ISTOR)=ED
      DO 82 IL=1,3
      ONE=1.0
      IF(T(IL,IL).LT.0.0) ONE=-1.0
      DO 82 JL=1,3
 82   TBEST(NOP,IL,JL,ISTOR)=ONE*T(IL,JL)
      LTZ(NOP,ISTOR)=LT
      LFZ(NOP,ISTOR)=LF
      LCZ(NOP,ISTOR)=LC
      DO 726 IL=1,3
 726  XOPT(NOP,IL,ISTOR)=XBR(IL)
      IF(NOP.EQ.2) IPREV(ISTOR)=KLP
 1010 CONTINUE     
      if(nop.eq.1.and.mpn.eq.2.and.iswm.eq.0) go to 727
      CALL ORIGIN(NOP,MPN,JPN,KPN,NATOM,XBR,MOLD)
      IF(ITRSA(NOP).EQ.0) GO TO 727
      CALL TRAS(VOLU,E12,ed,ilay,TCOR,nustr)
      if(nustr.gt.nsomax) return
 727  IF(ED.GT.ELD) GO TO 4013
      ELD=ED
c     end of euler rotation loops
4013  CONTINUE
4012  CONTINUE
 4011 CONTINUE
      INE(IIY,IIZ)=-ELD*10.0
 444  CONTINUE
C     Y-Z MAP FINISHED HERE        
 4    CONTINUE
      IF(NOP.EQ.3) GO TO 68
      if(ilevel(2).ne.0) WRITE(8,63) XBR(1),ZL,ZU,YL,YU,STPZ,STPY
 63   FORMAT(2X,'EN.MAP X=',F6.2 ,2X,'Z-HOR',2F6.2,
     1 1X,'Y-VERT',2F6.2,2X,'STEP Z,Y',2F6.2)
  64  FORMAT(30I5)
      DO 23 I=1,NUMY
      if(ilevel(2).ne.0) WRITE(8,64) (INE(I,J),J=1,NUMZ)
 23   CONTINUE
 68   CONTINUE
      DO 30 K=1,NUMY
      DO 30 M=1,NUMZ
 30   INE(K,M)=0
 443  CONTINUE
c     end of translation loops
      GO TO (755,754,1754), NOP
  755 MTOP(NOP)=ISTOR
      if(nop.ne.1.or.mpn.ne.2.or.iswm.ne.0) go to 700
c     --------------------------
c     double scan of energy surface for I clusters
c     to avoid duplication of very close points
c     ---------------------------
      if(istor.le.200) go to 822
      write(8,823) istor
 823  format(2x,'too many nuclei, please reset energy threshold',i5)
      stop 
 822  if(istor.eq.0) go to 700
      rmn=5.0*stpx
c     copy data into buffers
      do 812 i=1,istor
      iseq(i)=0
      ebf(i)=emx(1,i)
      do 812 j=1,3
 812  xbf(i,j)=xopt(1,j,i)
c     look for lowest energy
      nseq=0
 817  continue
      emn=0.0
      nseq=nseq+1
      do 813 i=1,istor
      if(iseq(i).ne.0) go to 813
      if(ebf(i).gt.emn) go to 813
      imin=i           
      emn=ebf(i)
      emx(1,nseq)=ebf(i)
      do 814 j=1,3
 814  xopt(1,j,nseq)=xbf(i,j)
 813  continue
      iseq(imin)=nseq
c     now 'burn out' all neighbours to lowest energy
      do 815 i=1,istor
      if(iseq(i).ne.0) go to 815
      r=0.0
      do 816 j=1,3
 816  r=r+(xopt(1,j,nseq)-xbf(i,j))**2
      r=sqrt(r)
      if(r.gt.rmn) go to 815
      iseq(i)=-1
 815  continue
c     check if job is done
      do 818 i=1,istor
      if(iseq(i).eq.0) go to 817
 818  continue  
c     now go to structure search
      do 825 i=1,nseq
      write(8,826) emx(1,i),(xopt(1,j,i),j=1,3)
 826  format(2x,'I pair accepted',f10.2,2x,3f9.3)
 825  continue
      if(nseq.le.5) go to 821
      write(8,829) nseq
 829  format(2x,'too many nuclei, please reset energy threshold',i5)
      stop
 821  mtop(1)=nseq
      do 831 i=1,nseq
      if(itrsa(1).eq.0) go to 831
      do 827 k=1,3
      xcall(k)=xopt(1,k,i)
      do 827 l=1,3
 827  tcor(k,l)=0.0
      write(8,841) i     
 841  format(2x,'now searching structures using I pair n.',i5)
      call euler (1,1,1,1)
      call origin(1,2,0,0,natom,xcall,0)
      call tras(volu,emx(1,i),emx(1,i),1,tcor,nustr)
      if(nustr.gt.nsomax) return
 831  continue
 700  write(8,565) nop,mtop(nop)
 565  format(2x,'operation',i4,2x,i6,2x,'clusters accepted')
c     end loop on three symmetry operations
  777 CONTINUE
      write(8,8385) (mop(i),jop(i),kop(i),i=1,3),nustr
 8385 format(1x,'promis called with',9i3,2x,i5,2x,'structures found')
      if(nustr.eq.0) stop
      RETURN
  999 CALL ERR
 8383 WRITE(8,8384) 
 8384 FORMAT(2X,'TOO MANY NUCLEI,skipping rest of the job')
      RETURN 
      END  
      SUBROUTINE ORIGIN(NOP,MPN,JPN,KPN,NATOM,XOPT,MOLD)
C     REFER COORDINATES OF ATOMS IN NUCLEUS TO APPROPRIATE ORIGIN
C     GO TO SECTION FOR FIRST,SECOND,THIRD OPERATION
      DIMENSION XOPT(3),XCE(3)
      COMMON/ORIG/MOP(3),JOP(3),KOP(3),ITRS(3),TFIRST(3,3),ITRSA(3)
      COMMON /BOXD/ X(8,120,3),SX(8,120,3)                            
      COMMON/SY/ISWM,nspgr(3)   
      GO TO (731,732,733),NOP
C     FIXING ORIGIN AFTER FIRST OPERATION
 731  CONTINUE
      GO TO (334,742,743,744,743,744,747), MPN
C     CENTER OF SYMMETRY
 742  DO 34 K=1,NATOM
      DO 34 L=1,3
      X(1,K,L)=X(1,K,L)-XOPT(L)
      X(2,K,L)=-X(1,K,L)
 34   CONTINUE
      GO TO 334
C     SCREW OR TWOFOLD
 743  DO 31 K=1,NATOM
      X(2,K,KPN)=X(1,K,KPN)+XOPT(KPN)
      DO 31 L=1,3
      IF(L.EQ.KPN) GO TO 31
      X(1,K,L)=X(1,K,L)-XOPT(L)
      X(2,K,L)=-X(1,K,L)
 31   CONTINUE
      GO TO 334
C     MIRROR OR GLIDE
 744  DO 32 K=1,NATOM
      X(1,K,KPN)=X(1,K,KPN)-XOPT(KPN)
      DO 33 L=1,3
 33   X(2,K,L)=X(1,K,L)
      X(2,K,KPN)=-X(1,K,KPN)
      X(2,K,JPN)=X(1,K,JPN)+XOPT(JPN)
 32   CONTINUE
      GO TO 334
C     CENTERING
 747  DO 39 K=1,NATOM
      DO 35 L=1,3
      X(2,K,L)=X(1,K,L)
      IF(L.EQ.KPN) GO TO 35
      X(2,K,L)=X(2,K,L)+XOPT(L)
 35   CONTINUE
 39   CONTINUE
      GO TO 334
C     FIXING THE ORIGIN AFTER THE SECOND OPERATION
C     GENERATE COORDIINATES FOR THE NEW MOLECULES
 732  CONTINUE
      CALL SYMNU(NATOM,MPN,JPN,KPN,XOPT)
      GO TO (999,334,533,534,533,534,999),MOLD
 533  GO TO (999,542,543,544,545,544,334), MPN
C     BRING ORIGIN TO CENTER OF SYMMETRY
 542   DO 560 K=1,3
 560  XCE(K)=XOPT(K)
 563  DO 501 K=1,4
      DO 561 L=1,NATOM
      DO 561 M=1,3
      X(K,L,M)=X(K,L,M)-XCE(M)
 561  CONTINUE
 501  CONTINUE
      GO TO 334
 544  IF(KPN.NE.KOP(1)) GO TO 334
C     RECOVER LOCATION OF CENTER OF SYMMETRY WHEN IT IS A PRODUCT
 555  DO 562 K=1,3
 562  XCE(K)=(X(1,1,K)+X(4,1,K))*0.5
      GO TO 563
C     P212121 OR P21212
 543  GO TO (573,573,572),KPN
C     P212121
 572  DO 571 K=1,4
      DO 571 L=1,NATOM
      X(K,L,2)=X(K,L,2)-XOPT(2)
 571  X(K,L,3)=X(K,L,3)-0.5*XOPT(3)
      GO TO 334
C     P21212
C     PUT ORIGIN ON PRODUCT TWOFOLD AXIS
 573  XORI=(X(1,1,1)+X(4,1,1))*0.5
      YORI=(X(1,1,2)+X(4,1,2))*0.5
      DO 574 K=1,4
      DO 574 L=1,NATOM
      X(K,L,1)=X(K,L,1)-XORI
 574  X(K,L,2)=X(K,L,2)-YORI
      GO TO 334
 534  GO TO (999,542,553,554,553,554,334), MPN      
 553  IF(KPN.EQ.KOP(1)) GO TO 555
C     ORIGIN TO SCREW OR TWOFOLD AXIS
 545  DO 557 K=1,4
      DO 557 L=1,NATOM
      DO 558 M=1,3   
      IF(M.EQ.KPN) GO TO 557
 558  X(K,L,M)=X(K,L,M)-XOPT(M)
 557  CONTINUE
      GO TO 334
C     GYZ+GZX, PCA21, RESET ORIGIN ON SECOND GLIDE
 554  DO 564 M=1,3
      XCE(M)=0.0
      IF(M.EQ.KPN) XCE(M)=XOPT(M)
 564  CONTINUE
      GO TO 563
C     FIXING THE ORIGIN AFTER THE THIRD OPERATION 
C     SINCE THE ONLY ALLOWED GROUPS ARE CENTROSYMMETRIC
C     (C2/C,PBCA,PNMA)
C     ORIGIN IS ALWAYS RESET TO CENTER OF SYMMETRY
C     NEEDED ONLY IF CENTER IS THE LAST OPERATION
C     OTHERWISE ALREADY SET IN PREVIOUS OPNS.
 733  CALL SYMNU(NATOM,MPN,JPN,KPN,XOPT)
      IF(MOP(3).NE.2) RETURN
      DO 103 I=1,8
      DO 103 J=1,NATOM
      DO 103 K=1,3
 103  X(I,J,K)=X(I,J,K)-XOPT(K)
 334  RETURN             
C     ERROR STOP
 999  CALL ERR
      END
      SUBROUTINE RETRA
C     READ SPECIFICATIONS FOR TRANSLATIONAL SEARCH
      COMMON /VARIA/ AX5,NMOL,CUT2,ESUB,FD1,FD2,FD3,FD4, NTOP,IWAR(3)
      COMMON/LMT/ R1(30),R2(30),R3(30),TET1(30),TET2(30),TET3(30),
     1 COT1(30),COT2(30),COT3(30),SIT1(30),SIT2(30),SIT3(30),
     2 PH1(30),PH2(30),PH3(30),COP1(30),COP2(30),COP3(30),
     3 SIP1(30),SIP2(30),SIP3(30),RMN(3),RMX(3),TEMIN(3),TEMAX(3),
     4 PHIMIN(3),PHIMAX(3),STEPR1,STEPR2,STEPR3,
     5 STEPT1,STEPT2,STEPT3,STEPF1,STEPF2,STEPF3,CKM,CKP,
     6 NR1,NR2,NR3,NT1,NT2,NT3,NP1,NP2,NP3
      COMMON/MINI/KI(12)
C     READ AND PUT OUT SEARCH LIMITS
      READ(3,92) ESUB,AXIS,CKM,CKP,(KI(I),I=1,12)
  92  FORMAT(4F8.2,12I1)
      READ(3,*) (RMN(I),RMX(I),I=1,3),STEPR1,STEPR2,STEPR3
      READ(3,*) (TEMIN(I),TEMAX(I),I=1,3),STEPT1,STEPT2,STEPT3
      READ(3,*) (PHIMIN(I),PHIMAX(I),I=1,3),STEPF1,STEPF2,STEPF3
      PZZ=0.0174533
      WRITE(8,63) RMN(1),RMX(1),STEPR1,RMN(2),RMX(2),STEPR2,
     1 RMN(3),RMX(3),STEPR3
      WRITE(8,64) TEMIN(1),TEMAX(1),STEPT1,TEMIN(2),TEMAX(2),
     1 STEPT2,TEMIN(3),TEMAX(3),STEPT3
      WRITE(8,65) PHIMIN(1),PHIMAX(1),STEPF1,
     1 PHIMIN(2),PHIMAX(2),STEPF2,PHIMIN(3),PHIMAX(3),STEPF3
      WRITE(8,616) AXIS
 616  FORMAT(2X,'Max translation vector in PACKT subroutine',F10.2)
 91   FORMAT(9F8.2)
 63   FORMAT(/2X,'rho min,max,step for a,b,c',3(3F6.2,2X))
 64   FORMAT(2X,'corresponding theta ranges',3(3F6.1,2X))
 65   FORMAT(2X,'corresponding phi ranges',3(3F6.1,2X))
      WRITE(8,66) ESUB 
 66   FORMAT(2X,'Energy threshold for accepting structures in TRAS',
     1 F8.2)     
      WRITE(8,67) CKM,CKP
 67   FORMAT(2X,'Packing coefficient range for the same',3F10.3)
      WRITE(8,68) (KI(I),I=1,12)
 68   FORMAT(2X,'KI Vector',2X,12I1)
C     PREPARE TABLES OF ANGULAR AND TRANSLATION VALUES
      IF(STEPR1.EQ.0.0) GO TO 41
      NR1=(RMX(1)-RMN(1))/STEPR1+1.
      GO TO 42
 41   NR1=1
 42   IF(STEPR2.EQ.0.0) GO TO 43
      NR2=(RMX(2)-RMN(2))/STEPR2+1.
      GO TO 44
 43   NR2=1
 44   IF(STEPR3.EQ.0.0) GO TO 45
      NR3=(RMX(3)-RMN(3))/STEPR3+1.
      GO TO 46
 45   NR3=1
 46   IF(STEPT1.EQ.0.0) GO TO 47
      NT1=(TEMAX(1)-TEMIN(1))/STEPT1+1.
      GO TO 48
 47   NT1=1
 48   IF(STEPT2.EQ.0.0) GO TO 49
      NT2=(TEMAX(2)-TEMIN(2))/STEPT2+1.
      GO TO 50
 49   NT2=1
 50   IF(STEPT3.EQ.0.0) GO TO 51
      NT3=(TEMAX(3)-TEMIN(3))/STEPT3+1.
      GO TO 52
 51   NT3=1
 52   IF(STEPF1.EQ.0.0) GO TO 53
      NP1=(PHIMAX(1)-PHIMIN(1))/STEPF1+1.
      GO TO 54
 53   NP1=1
 54   IF(STEPF2.EQ.0.0) GO TO 55
      NP2=(PHIMAX(2)-PHIMIN(2))/STEPF2+1.
      GO TO 56
 55   NP2=1
 56   IF(STEPF3.EQ.0.0) GO TO 57
      NP3=(PHIMAX(3)-PHIMIN(3))/STEPF3+1.
      GO TO 58
 57   NP3=1
 58   CONTINUE
      DO 31 I=1,NR1
 31   R1(I)=(I-1)*STEPR1+RMN(1)
      DO 32 I=1,NR2
 32   R2(I)=(I-1)*STEPR2+RMN(2)
      DO 33 I=1,NR3
 33   R3(I)=(I-1)*STEPR3+RMN(3)
      DO 34 I=1,NT1
      TET1(I)=(I-1)*STEPT1+TEMIN(1)
      SIT1(I)=SIN(TET1(I)*PZZ)
 34   COT1(I)=COS(TET1(I)*PZZ)
      DO  35 I=1,NT2
      TET2(I)=(I-1)*STEPT2+TEMIN(2)
      COT2(I)=COS(TET2(I)*PZZ)
 35   SIT2(I)=SIN(TET2(I)*PZZ)
      DO 36 I=1,NT3
      TET3(I)=(I-1)*STEPT3+TEMIN(3)
      COT3(I)=COS(TET3(I)*PZZ)
 36   SIT3(I)=SIN(TET3(I)*PZZ)
      DO 37 I=1,NP1
      PH1(I)=(I-1)*STEPF1+PHIMIN(1)
      COP1(I)=COS(PH1(I)*PZZ)
 37   SIP1(I)=SIN(PH1(I)*PZZ)
      DO 38 I=1,NP2
      PH2(I)=(I-1)*STEPF2+PHIMIN(2)
      COP2(I)=COS(PH2(I)*PZZ)
 38   SIP2(I)=SIN(PH2(I)*PZZ)
      DO 39 I=1,NP3
      PH3(I)=(I-1)*STEPF3+PHIMIN(3)
      COP3(I)=COS(PH3(I)*PZZ)
 39   SIP3(I)=SIN(PH3(I)*PZZ)
      RETURN
      END
      SUBROUTINE TRAS (VOLU,BEST,enucl,ilay,TBEST,nustr)
C     SEQUENTIAL OPTIMIZATION OF T MATRIX
      DIMENSION TBEST(3,3),IWAS(3) 
      COMMON/MEMO/XBG(3),LT,LF,LC,RR1,RR2,RR3,PHI1,PHI2,PHI3,
     1 TETA1,TETA2,TETA3
      COMMON/ORIG/MOP(3),JOP(3),KOP(3),ITRS(3),TFIRST(3,3),ITRSA(3)
      COMMON/HALF/HALF,nsomax
      COMMON /VARIA/ AX5,NMOL,CUT2,ESUB,FD1,FD2,FD3,FD4, NTOP,IWAR(3)
      COMMON /LRS/ BRUF(120,3)
c      COMMON/OPEC1/ALFA(7000,3),RM(800,3,3),QRG(120),NPE
c      COMMON/OPEC2/ PESO(120),CUTOFF,ILEVEL(5),ISPEN(120),TIPO(15,15,3),
c     1 NATOM,NA,NAA,NB,NC,ND,NE,NF,NG,NH,NI,NL,NM,NEE,NEM,NEF,NEL,NEP,
c     2 NDD,NDE,NDF,NDG,NDH
      COMMON /RESU/ XBR(3),ine(100,100),XOPT(2,3,2000),
     1 T(3,3),TRA(3),EMX(2,2000),MTOP(3),TCOR(3,3)
      COMMON /BOXD/ X(8,120,3),SX(8,120,3)                            
      COMMON/LMT/ R1(30),R2(30),R3(30),TET1(30),TET2(30),TET3(30),
     1 COT1(30),COT2(30),COT3(30),SIT1(30),SIT2(30),SIT3(30),
     2 PH1(30),PH2(30),PH3(30),COP1(30),COP2(30),COP3(30),
     3 SIP1(30),SIP2(30),SIP3(30),RMN(3),RMX(3),TEMIN(3),TEMAX(3),
     4 PHIMIN(3),PHIMAX(3),STEPR1,STEPR2,STEPR3,
     5 STEPT1,STEPT2,STEPT3,STEPF1,STEPF2,STEPF3,CKM,CKP,
     6 NR1,NR2,NR3,NT1,NT2,NT3,NP1,NP2,NP3
      COMMON/SY/ISWM,nspgr(3)   
      PZZ=0.0174533
C     RETRIEVE BEST T-MATRIX FROM PROMIS SUBROUTINE
 52   DO 99 I=1,3
      IWAR(I)=0
      DO 99 J=1,3
      IF(TBEST(I,J).NE.0.0) IWAR(I)=1
 99   T(I,J)=TBEST(I,J)
      DO 100 I=1,3
 100  IWAS(I)=IWAR(I)
C     SIDESTEP TRAS LOOPS IF UNNECESSARY
      IF(IWAS(1).EQ.0) GO TO 91
      NR1=1
      NT1=1
      NP1=1
 91   IF(IWAS(2).EQ.0) GO TO 92
      NR2=1
      NT2=1
      NP2=1
 92   IF(IWAS(3).EQ.0) GO TO 93
      NR3=1
      NT3=1
      NP3=1
 93   CONTINUE
      VOLM=FLOAT(NTOP)*VOLU
C     FIRST TEST FOR ENERGY IS ENERGY OF NUCLEUS
      E=BEST
C     MAIN LOOPS START HERE
      DO 3 I=1,NR1
      RO1=R1(I)
      DO 4 J=1,NT1
      TETA1=TET1(J)
      CO1=COT1(J)
      SI1=SIT1(J)
      DO 5 K=1,NP1
 641  PHI1=PH1(K)
C     IWAS NE 0 THE CORRESPONDING ROW OF T MATRIX IS FILLED
C     IWAR  SAME MEANING, BUT FOR TEMPORARY CALL TO PACKT
      IF(IWAS(1).NE.0) GO TO 642
      T(1,1)=RO1*COP1(K)*CO1
      T(1,2)=RO1*COP1(K)*SI1
      T(1,3)=RO1*SIP1(K)
      IWAR(1)=1
C     COMPUTE PACKING ENERGY OF ONE-D ROW
      CALL PACKT(E)
      IF(E.GT.BEST) GO TO 5
 642  EROW=E
 501  RR1=SQRT(T(1,1)**2+T(1,2)**2+T(1,3)**2)
C     START LOOPS FOR TWO-D SPREADING
      DO 6 L=1,NR2
      RO2=R2(L)
c     check for cell parameters in ascending order
c     unless cell is a guessed one
      if(nr2.lt.3) go to 40
      if(nspgr(1).eq.3.and.ro2.lt.ro1) go to 6
 40   continue
      DO 7 M=1,NT2
      CO2=COT2(M)
      SI2=SIT2(M)
      TETA2=TET2(M)
      DO 8 N=1,NP2
 643  PHI2=PH2(N)
      IF(IWAS(2).NE.0) GO TO 644
      T(2,1)=RO2*COP2(N)*CO2
      T(2,2)=RO2*COP2(N)*SI2
      T(2,3)=RO2*SIP2(N)
      IWAR(2)=1
C     COMPUTE PACKING ENERGY FOR TWO-D ARRAY
      CALL PACKT(E)
      IF(E.GT.EROW) GO TO 8
644   RR2=SQRT(T(2,1)**2+T(2,2)**2+T(2,3)**2)
      R12=RR1*RR2
      GAX=(T(1,1)*T(2,1)+T(1,2)*T(2,2)+T(1,3)*T(2,3))/R12
C     EXIT IF ANGLE BETWEEN VECTORS GT 120 OR LT 60
      IF(ABS(GAX).GT.HALF) GO TO 8
C     START LOOPS FOR THREE-D SPREADING
      DO 9 LL=1,NR3
      RO3=R3(LL)
      if(nr3.lt.3) go to 41
      if(nspgr(1).eq.3.and.ro3.lt.ro2) go to 9
      if(nspgr(1).eq.1.and.ro3.lt.ro1) go to 9
  41  continue
      DO 10 MM=1,NT3
      CO3=COT3(MM)
      SI3=SIT3(MM)
      TETA3=TET3(MM)
      DO 11 NN=1,NP3
 645  PHI3=PH3(NN)
      IF(IWAS(3).NE.0) GO TO 654
      T(3,1)=RO3*COP3(NN)*CO3
      T(3,2)=RO3*COP3(NN)*SI3
      T(3,3)=RO3*SIP3(NN)
      IWAR(3)=1
 654  RR3=SQRT(T(3,1)**2+T(3,2)**2+T(3,3)**2)
      R13=RR1*RR3
      R23=RR2*RR3
      R123=RR1*RR2*RR3
      ALX=(T(2,1)*T(3,1)+T(2,2)*T(3,2)+T(2,3)*T(3,3))/R23
      IF(ABS(ALX).GT.HALF) GO TO 11
      BEX=(T(1,1)*T(3,1)+T(1,2)*T(3,2)+T(1,3)*T(3,3))/R13
      IF(ABS(BEX).GT.HALF) GO TO 11
      VCEL=1.-(ALX*ALX+BEX*BEX+GAX*GAX)+2.*ALX*BEX*GAX
      if(vcel.lt.0.000001) go to 11
      VCEL=R123*SQRT(VCEL)
      CK=VOLM/VCEL
C     JUMP OUT IF PACKING COEFFICIENT IS TOO LOW OR TOO HIGH
      IF(CK.LT.CKM.OR.CK.GT.CKP) GO TO 11
C     COMPUTE THREE-D PACKING ENERGY
c     unless ilay=4, where 3D energy is nucleus energy
      e=enucl
      if(ilay.ne.4) CALL PACKT(E)
C     CHECK IF IT IS WORTH OPTIMIZING THIS THREE-D STRUCTURE
      IF(E.GT.ESUB)GO TO 11
 647  ALF=ACOS(ALX)/PZZ
      BET=ACOS(BEX)/PZZ
      GAM=ACOS(GAX)/PZZ
      ded=e-esub
      dis=0.2*esub
      if(dis.le.ded) go to 291
      esub=esub+0.1*(ded-dis) 
      write(8,292) esub
 292  format(20x,'resetting pemin',f10.2)
 291  nustr=nustr+1
c     stop search if max n. of required structures is exceeded
      if(nustr.gt.nsomax) return
      WRITE(8,74) nustr,RR1,RR2,RR3,ALF,BET,GAM,VCEL,CK,E 
c    1            TETA1,TETA2,TETA3,PHI1,PHI2,PHI3
 74   FORMAT(1X,'cell',i5,3F6.2,3F6.1,F7.1,F6.3,F7.1,6F6.0) 
 75   FORMAT(6F10.4,2F8.1)
C     OPTIMIZE TRIAL STRUCTURE 
 646  CALL OPTI(RR1,RR2,RR3,ALF,BET,GAM,E,vcel,nustr)
C     CLOSE LOOPS
 11   CONTINUE
 10   CONTINUE
 9    CONTINUE
      DO 201 LZ=1,3
 201  T(3,LZ)=TBEST(3,LZ)
      IWAR(3)=IWAS(3)
 8    CONTINUE
 7    CONTINUE
 6    CONTINUE
      DO 202 LZ=1,3
 202  T(2,LZ)=TBEST(2,LZ)
      IWAR(2)=IWAS(2)
 5    CONTINUE
 4    CONTINUE
 3    CONTINUE
      RETURN
      END
      SUBROUTINE PACKT(E)
      DIMENSION XT(3)
      COMMON /VARIA/ AX5,NMOL,CUT2,ESUB,FD1,FD2,FD3,FD4, NTOP,IWAR(3)
      COMMON/OPEC2/ PESO(120),CUTOFF,ILEVEL(5),ISPEN(120),TIPO(15,15,3),
     1 NATOM,NA,NAA,NB,NC,ND,NE,NF,NG,NH,NI,NL,NM,NEE,NEM,NEF,NEL,NEP,
     2 NDD,NDE,NDF,NDG,NDH
      COMMON /BOXD/ X(8,120,3),SX(8,120,3)                            
      COMMON/XEN/TABEN(8,8,700),CT(361),ST(361)
      COMMON /RESU/ XBR(3),ine(100,100),XOPT(2,3,2000),
     1 T(3,3),TRA(3),EMX(2,2000),MTOP(3),TCOR(3,3)
      COMMON/SY/ISWM,nspgr(3)   
C     COMPUTES ACTUAL TRANSLATIONS AND PACKING ENERGY
      E=0.0
      L1=-2*IWAR(1)+3
      L2=2*IWAR(1)+3 
      L3=-2*IWAR(2)+3
      L4=2*IWAR(2)+3
      L5=-2*IWAR(3)+3
      L6=2*IWAR(3)+3
 3    DO 33 I=L1,L2
      DO 33 J=L3,L4
      DO 33 K=L5,L6
      TRA(1)=T(1,1)*(I-3)+T(2,1)*(J-3)+T(3,1)*(K-3)
      TRA(2)=T(1,2)*(I-3)+T(2,2)*(J-3)+T(3,2)*(K-3)
      TRA(3)=T(1,3)*(I-3)+T(2,3)*(J-3)+T(3,3)*(K-3)
C      JUMP OUT IF TOTAL TRANSLATION IS TOO LONG
      RT=TRA(1)**2+TRA(2)**2+TRA(3)**2
      IF(RT.GT.AX5) GO TO 33
      LOW=1
      IF(I.EQ.3.AND.J.EQ.3.AND.K.EQ.3) GO TO 114
      GO TO 113
 114  IF(NTOP.EQ.1) GO TO 33
      LOW=2
 113  DO 34 L=1,NATOM
      JJ=ISPEN(L)
      DO 35 M=LOW,NTOP
C     CHECK IF MOLECULE HAS INTERNAL  SYMMETRY
C     IN THAT CASE SKIP ENERGY BETWEEN FIRST TWO FRAGMENTS
      IF(ISWM.EQ.0) GO TO 201
      IF(RT.NE.0.0) GO TO 201
      IF(M.NE.2) GO TO 201
      GO TO 35
 201  CONTINUE
      DO 36 N=1,NATOM
      KK=ISPEN(N)
      XT(1)=X(M,N,1)+TRA(1)
      XT(2)=X(M,N,2)+TRA(2)
      XT(3)=X(M,N,3)+TRA(3)
      R=(X(1,L,1)-XT(1))**2+(X(1,L,2)-XT(2))**2+(X(1,L,3)-XT(3))**2
 41   IF(R.GT.CUT2) GO TO 36
      INR=AINT(SQRT(R)*100.)
      IF(INR.LT.10) INR=1             
      E=E+TABEN(JJ,KK,INR)
c     jump out if repulsive contact is detected
      IF(E.LT.20.0) GO TO 36 
      E=0.0
      GO TO 101
 36   CONTINUE
 35   CONTINUE
 34   CONTINUE
 33   CONTINUE
 101  CONTINUE
C    DOUBLE ENERGY IF MOLECULE HAS INTERNAL  SYMMETRY
      IF(ISWM.NE.0) E=2.0*E
      e=0.5*e
      RETURN
      END
      SUBROUTINE OPTI(A,B,C,ALFZ,BETA,GAMA,ESTRC,VCC,nustr)
      DIMENSION AX(3),TEMQ(120,3),WW(120,3)
      COMMON/TIPI/ WEI(30),RAVDW(30),RAVRG(30),FL(30)
      common/moldim/volu,dmomax,dmomed,dmomin
      COMMON /VARIA/ AX5,NMOL,CUT2,ESUB,FD1,FD2,FD3,FD4, NTOP,IWAR(3)
      COMMON /LRS/ BRUF(120,3)
      COMMON/OPEC1/ALFA(7000,3),RM(800,3,3),QRG(120),NPE
      COMMON/OPEC2/ PESO(120),CUTOFF,ILEVEL(5),ISPEN(120),TIPO(15,15,3),
     1 NATOM,NA,NAA,NB,NC,ND,NE,NF,NG,NH,NI,NL,NM,NEE,NEM,NEF,NEL,NEP,
     2 NDD,NDE,NDF,NDG,NDH
      COMMON /RESU/ XBR(3),ine(100,100),XOPT(2,3,2000),
     1 T(3,3),TRA(3),EMX(2,2000),MTOP(3),TCOR(3,3)
      COMMON /BOXD/ X(8,120,3),SX(8,120,3)                            
      COMMON/MINI/KI(12)
      COMMON/OPTU/XDE(120,3),XDO(120,3),DER(12),SPO(12)
      COMMON/SY/ISWM,nspgr(3)   
C     PRODUCE SOLUTION IN CRYSTALLOGRAPHIC FORM
      NAZ=NATOM/2
      PZZ=0.0174533
C     PREPARE TRANSFORMATION TO CELL REFERENCE SYSTEM
      AX(1)=A
      AX(2)=B
      AX(3)=C
      DO 131 I=1,3
      DO 131 J=1,3
 131  RM(NDH,I,J)=T(J,I)/AX(J)
      CALL INV (NDH,NDD)
C     PREPARE FINAL FRACTIONAL COORDINATES
C     DOUBLE ATOM NUMBER IF MOLECULE HAS INTERNAL  SYMMETRY
      DO 305 I=1,NATOM
      DO 305 J=1,3
      WW(I,J)=X(1,I,J)
      IF(ISWM.EQ.0) GO TO 305
      IKK=I+NATOM
      WW(IKK,J)=X(2,I,J)
 305  CONTINUE
      IF(ISWM.EQ.0) GO TO 306
      DO 307 I=1,NATOM
      IKK=I+NATOM
      ISPEN(IKK)=ISPEN(I)
      PESO(IKK)=PESO(I)
      QRG(IKK)=QRG(I)
 307  CONTINUE
 306  CONTINUE
      IF(ISWM.NE.0) NATOM=2*NATOM
C     DEORTHOGONALIZE
 398  DO 92 I=1,NATOM
      DO 93 J=1,3
      TEMQ(I,J)=0.0
      DO 94 K=1,3
 94   TEMQ(I,J)=TEMQ(I,J)+RM(NDD,J,K)*WW(I,K)
      TEMQ(I,J)=TEMQ(I,J)/AX(J)
 93   ALFA(I,J)=TEMQ(I,J)
 92   CONTINUE
c     at this point, atomic coordinates for the new crystal
c     are in the usual position for OPEC-oriented use
c
c     now prepare file for communication with sorter routines
c
      WRITE(10,171) nustr,vcc,estrc   
 171  FORMAT(2x,'structure n.',i5,2x,f10.2,f10.2)
      dmom=dmomax-3.0
      write(10,178) ki,dmom
 178  format(12i1,f10.3)
      write(10,179) 0,31,0,10.,-10.
 179  format(3i5,2f10.2)
      WRITE(10,177) A,B,C,ALFZ,BETA,GAMA
 177  FORMAT(6F10.4)
      DO 174 I=1,NATOM
      is=ispen(i)
      WRITE(10,175) i,(TEMQ(I,J),J=1,3),peso(i),ISPEN(I),
     1 qrg(i),ravdw(is)
 175  FORMAT(i5,3F10.4,F10.4,4x,I5,F10.5,f5.2)
 174  CONTINUE
      write(10,175) 999
      DO 172 I=1,NPE
      M=I+NH
      WRITE(10,173) ((RM(I,J,K),K=1,3),J=1,3)
      write(10,173) (alfa(m,j),j=1,3) 
 173  FORMAT(9f5.1)         
 172  CONTINUE
      write(10,173) 99.
c     stoppers
      write(10,90) 98,1,3,99,98
 90   format(i5/2i3/i3/i4)
      IF(ISWM.NE.0) NATOM=NATOM/2
      RETURN
      END
      subroutine write9 (ifi,ila,esub,axis,ckm,ckp,ki,a1,a2,a3,a4,a5,
     1 a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,
     2 a21,a22,a23,a24,a25,a26,a27)
      dimension syym(7,12),buf(12),ki(12)
      rewind  2
      if(ifi.ne.0) go to 77
      write(3,*) 0
      go to 78
 77   iskip=(ifi-1)*2
      do 2 i=1,iskip
 2    read(2,3) dummy
 3    format(a1)
      neq=ila-ifi+1
      do 1 i=1,neq
      read(2,*) (buf(k),k=1,9)                  
      read(2,*) (buf(k),k=10,12)   
      do 22 k=1,12
 22   syym(i,k)=buf(k)
 1    continue
      write(3,*) neq
      do 11 i=1,neq
      write(3,881) (syym(i,j),j=1,12)
 11   continue
 78   write(3,693) esub,axis,ckm,ckp,ki
 693  format(4f8.2,18i1,3f10.0)
      write(3,691) a1,a2,a3,a4,a5,a6,a7,a8,a9         
 691  format(9f10.2)
      write(3,691) a10,a11,a12,a13,a14,a15,a16,a17,a18
      write(3,691) a19,a20,a21,a22,a23,a24,a25,a26,a27          
 881  format(9f7.1,3f9.3)
      return
      end
      SUBROUTINE ERR
C     ERROR MESSAGE
      WRITE(8,1) 
 1    FORMAT(//2X,'SOMETHING WRONG, PROGRAM CANNOT CONTINUE')
      STOP
      END
C     THIS SUBROUTINE DOES THE MAIN SYMMETRY OPERATION FOR
C     THE BUILDING UP OF NUCLEI
      SUBROUTINE SYMNU (NATOM,MPN,JPN,KPN,XAR)
      DIMENSION XAR(3)
      COMMON /BOXD/ X(8,120,3),SX(8,120,3)                            
      COMMON /VARIA/ AX5,NMOL,CUT2,ESUB,FD1,FD2,FD3,FD4, NTOP,IWAR(3)
      COMMON /SMAT/ ROG(3,3),TOG(3)   
      COMMON/SY/ISWM,nspgr(3)   
C     PREPARE ONLY TRANSLATION OF FIRST MOLECULE IF BRUTE FORCE APPROACH
      IF(MPN.NE.99) GO TO 750
      DO 751 I=1,NATOM
      DO 751 J=1,3
 751  X(1,I,J)=X(1,I,J)+XAR(J)
      RETURN
C     PREPARE MATRIX AND VECTOR FOR GENERATION OF NEW MOLECULES
C     ACCORDING TO NUCLEUS SYMMETRY
 750  DO 711 I=1,3
      TOG(I)=2.0*XAR(I)
      DO 711 J=1,3
      ROG(I,J)=0.0
 711  ROG(I,I)=-1.0
      GO TO (102,712,713,714,713,714,717),MPN
C     TWOFOLD AXIS OR TWOONE AXIS
 713  ROG(KPN,KPN)=1.0
      TOG(KPN)=XAR(KPN)
      IF(MPN.EQ.5) GO TO 720
      GO TO 712
 720  TOG(KPN)=0.0
      GO TO 712
C     MIRROR PLANE OR GLIDE PLANE
 714  DO 719 I=1,3
      IF(I.EQ.KPN) GO TO 719
      TOG(I)=0.0
      ROG(I,I)=1.0
 719  CONTINUE
      IF(MPN.NE.4) GO TO 712
      TOG(JPN)=XAR(JPN)
      GO TO 712
C     CENTERING
 717  DO 715 I=1,3
      TOG(I)=XAR(I)
 715  ROG(I,I)=1.0
 712  CONTINUE
      DO 1 I=1,NMOL
      L=I+NMOL
      DO 2 J=1,NATOM
      DO 3 K=1,3
      X(L,J,K)=0.0
      DO 4 M=1,3
 4    X(L,J,K)=X(L,J,K)+ROG(K,M)*X(I,J,M)
 3    X(L,J,K)=X(L,J,K)+TOG(K)
 2    CONTINUE
 1    CONTINUE
 102  RETURN
      END
C     THIS SUBROUTINE DOES THE EULER ANGLE ROTATION
      SUBROUTINE EULER(LT,LF,LC,NUMOL) 
      DIMENSION EU(3,3)
      COMMON/XEN/TABEN(8,8,700),CT(361),ST(361)
      COMMON/OPEC2/ PESO(120),CUTOFF,ILEVEL(5),ISPEN(120),TIPO(15,15,3),
     1 NATOM,NA,NAA,NB,NC,ND,NE,NF,NG,NH,NI,NL,NM,NEE,NEM,NEF,NEL,NEP,
     2 NDD,NDE,NDF,NDG,NDH
      COMMON /BOXD/ X(8,120,3),SX(8,120,3)                            
      EU(1,1)=CT(LT)*CT(LF)*CT(LC)-ST(LF)*ST(LC)
      EU(1,2)=CT(LT)*ST(LF)*CT(LC)+CT(LF)*ST(LC)
      EU(1,3)=-ST(LT)*CT(LC)
      EU(2,1)=-CT(LT)*CT(LF)*ST(LC)-ST(LF)*CT(LC)
      EU(2,2)=-CT(LT)*ST(LF)*ST(LC)+CT(LF)*CT(LC)
      EU(2,3)= ST(LT)*ST(LC)
      EU(3,1)=ST(LT)*CT(LF)
      EU(3,2)=ST(LT)*ST(LF)
      EU(3,3)=CT(LT)
      DO 2 J=1,NUMOL
      DO 1 I=1,NATOM
      X(J,I,1)=SX(J,I,1)*EU(1,1)+SX(J,I,2)*EU(1,2)+SX(J,I,3)*EU(1,3)
      X(J,I,2)=SX(J,I,1)*EU(2,1)+SX(J,I,2)*EU(2,2)+SX(J,I,3)*EU(2,3)
      X(J,I,3)=SX(J,I,1)*EU(3,1)+SX(J,I,2)*EU(3,2)+SX(J,I,3)*EU(3,3)
 1    CONTINUE
 2    CONTINUE 
      RETURN
      END
      SUBROUTINE WRMA (NOVEC,NOMAT,iret)
C     COMPUTES AND PRINTS COORDINATES OF MOL. IN ITS LRS
      COMMON /LRS/ BRUF(120,3)
      COMMON/OPEC1/ALFA(7000,3),RM(800,3,3),QRG(120),NPE
      COMMON/OPEC2/ PESO(120),CUTOFF,ILEVEL(5),ISPEN(120),TIPO(15,15,3),
     1 NATOM,NA,NAA,NB,NC,ND,NE,NF,NG,NH,NI,NL,NM,NEE,NEM,NEF,NEL,NEP,
     2 NDD,NDE,NDF,NDG,NDH
      COMMON/SY/ISWM,nspgr(3)   
      DO 10 K=1,NATOM
      DO 10 J=1,3
 10   BRUF(K,J)=0.0
      DO 1 J=1,NATOM
      IF(ISPEN(J).EQ.0) GO TO 1
      JP=J+nm     
      CALL SOMA (JP,NOVEC,NEL)
      CALL PRTR (NOMAT,NEL,NEL)
      DO 2 K=1,3
 2    BRUF(J,K)=ALFA(NEL,K)
 1    CONTINUE
      if(iret.eq.1) return
      WRITE(8,3) ((RM(NOMAT,L,M),M=1,3),L=1,3),(ALFA(NOVEC,N),N=1,3)
 3    FORMAT  (2X,'LOCAL REFERENCE SYSTEM MATRIX'/(2X,3F8.4))
      WRITE(8,5)
 5    FORMAT(/2X,'ATOMIC COORDINATES,LOCAL REF.SYSTEM')
      WRITE(8,4) (K,(BRUF(K,L),L=1,3),K=1,NATOM)
 4    FORMAT(3(I3,3F7.3))
      RETURN
      END
      SUBROUTINE REDEN 
      DIMENSION ITY(15)
      COMMON/XEN/TABEN(8,8,700),CT(361),ST(361)
      COMMON/OPEC2/ PESO(120),CUTOFF,ILEVEL(5),ISPEN(120),TIPO(15,15,3),
     1 NATOM,NA,NAA,NB,NC,ND,NE,NF,NG,NH,NI,NL,NM,NEE,NEM,NEF,NEL,NEP,
     2 NDD,NDE,NDF,NDG,NDH
      COMMON/TIPI/ WEI(30),RAVDW(30),RAVRG(30),FL(30)             
C     LOAD POTENTIAL PARAMETER LIBRARY
      CALL PPOTE
 11   READ(1,1) I,J,A,B,C
      IF(I.EQ.98) GO TO 50
      if(i.gt.8.or.j.gt.8) call err
      WRITE(8,4)
 4    FORMAT  (2X,25HINPUT INTERACTION CURVES,,2X,9HSPECIES  ,
     *5X,5HA,B,C)
 1    FORMAT(2I5,3F10.0)
      TIPO(I,J,1)=A
      TIPO(I,J,2)=B
      TIPO(I,J,3)=C
      TIPO(J,I,1)=A
      TIPO(J,I,2)=B
      TIPO(J,I,3)=C
      WRITE(8,5) I,J,(TIPO(I,J,K),K=1,3)
 5    FORMAT(2X,2I5,2X,F10.2,F8.3,F8.3)
      GO TO 11
 50   IND=0
C     PROVIDE LIBRARY PARAMETERS
      DO 30  I=1,15
 30   ITY(I)=0
      DO 20 I=1,NATOM
      ISO=ISPEN(I)
      DO 21 J=1,15
      IF(ISO.EQ.ITY(J)) GO TO 20
 21   CONTINUE
      IND=IND+1
      ITY(IND)=ISO
 20   CONTINUE
      WRITE(8,22)
 22   FORMAT  (/' POTENTIAL PARAMETERS, Aexp(-Br-Cr**-6')
      DO 31 I=1,IND
      IS1=ITY(I)
      DO 32 J=I,IND
      IS2=ITY(J)
      ISTIP=TIPO(IS1,IS2,1)
      IF(ISTIP.GT.0) GO TO 33
      WRITE(8,34) IS1,IS2
 34   FORMAT (2X,'Supply missing parameters for',2I5)
      TIPO(IS1,IS2,1)=(TIPO(IS1,IS1,1)*TIPO(IS2,IS2,1))**0.5
      TIPO(IS1,IS2,3)=(TIPO(IS1,IS1,3)*TIPO(IS2,IS2,3))**0.5
      TIPO(IS1,IS2,2)=    (TIPO(IS1,IS1,2)+TIPO(IS2,IS2,2))*0.5
      DO 37 K=1,3
 37   TIPO(IS2,IS1,K)=TIPO(IS1,IS2,K)
  33  WRITE(8,35) IS1,IS2,(TIPO(IS1,IS2,L),L=1,3)
 35   FORMAT(5X,2I5,2X,F12.2,F8.3,F8.2)
 32   CONTINUE
 31   CONTINUE
C     PREPARE TABLES OF ATOM-ATOM ENERGY VALUES
      DO 101 I=130,700
      R=FLOAT(I)/100.
      DO 102 K=1,8
      DO 102 L=K,8
      TABEN(K,L,I)=TIPO(K,L,1)*EXP(-TIPO(K,L,2)*R)
     1 -TIPO(K,L,3)*R**(-6)
      TABEN(L,K,I)=TABEN(K,L,I)
 102  CONTINUE
 101  CONTINUE
      DO 103 K=1,8
      DO 103 L=1,8
      DO 103 I=1,129
C     ENERGY BELOW 1.3 A IS SET AT 200 AS A POINTER OF SHORT CONTACT
      TABEN(K,L,I)=200.
 103  CONTINUE
      PZ=0.0174533
C     PREPARE TRIGONOMETRIC TABLES FOR EULER ROTATIONS
      DO 601 I=1,361
      ANG=(I-1)*PZ
      CT(I)=COS(ANG)
      ST(I)=SIN(ANG)
 601  CONTINUE
      RETURN
      END
C     THIS SUBROUTINE ASSIGNS POTENTIAL ENERGY PARAMETERS
C     VERSION OF JANUARY 1998
C     1 H   2 H ACIDS   3 C   4 N   5 O
C     6 =O ACIDS     7 =O AMIDES    8 H AMIDES
      SUBROUTINE PPOTE
      COMMON/OPEC2/ PESO(120),CUTOFF,ILEVEL(5),ISPEN(120),TIPO(15,15,3),
     1 NATOM,NA,NAA,NB,NC,ND,NE,NF,NG,NH,NI,NL,NM,NEE,NEM,NEF,NEL,NEP,
     2 NDD,NDE,NDF,NDG,NDH
      DO 1 I=1,15
      DO 1 J=1,15
      DO 1 K=1,3
 1    TIPO(I,J,K)=0.0
      TIPO(1,1,1)=    24158.42
      TIPO(1,1,2)=        4.01
      TIPO(1,1,3)=      109.20
      TIPO(1,2,1)=    24158.42
      TIPO(1,2,2)=        4.01
      TIPO(1,2,3)=      109.20
      TIPO(1,3,1)=   120792.10
      TIPO(1,3,2)=        4.10
      TIPO(1,3,3)=      472.79
      TIPO(1,4,1)=   228279.00
      TIPO(1,4,2)=        4.52
      TIPO(1,4,3)=      502.08
      TIPO(1,5,1)=   295432.30
      TIPO(1,5,2)=        4.82
      TIPO(1,5,3)=      439.32
      TIPO(1,6,1)=   295432.30
      TIPO(1,6,2)=        4.82
      TIPO(1,6,3)=      439.32
      TIPO(1,7,1)=   295432.30
      TIPO(1,7,2)=        4.82
      TIPO(1,7,3)=      439.32
      TIPO(1,8,1)=    24158.42
      TIPO(1,8,2)=        4.01
      TIPO(1,8,3)=      109.20
      TIPO(2,2,1)=    24158.42
      TIPO(2,2,2)=        4.01
      TIPO(2,2,3)=      109.20
      TIPO(2,3,1)=   120792.10
      TIPO(2,3,2)=        4.10
      TIPO(2,3,3)=      472.79
      TIPO(2,4,1)=   228279.00
      TIPO(2,4,2)=        4.52
      TIPO(2,4,3)=      502.08
      TIPO(2,5,1)=   295432.30
      TIPO(2,5,2)=        4.82
      TIPO(2,5,3)=      439.32
      TIPO(2,6,1)= 26416400.00
      TIPO(2,6,2)=        8.75
      TIPO(2,6,3)=      857.72
      TIPO(3,3,1)=   226145.20
      TIPO(3,3,2)=        3.47
      TIPO(3,3,3)=     2418.35
      TIPO(3,4,1)=   491494.50
      TIPO(3,4,2)=        3.86
      TIPO(3,4,3)=     2790.73
      TIPO(3,5,1)=   393086.80
      TIPO(3,5,2)=        3.74
      TIPO(3,5,3)=     2681.94
      TIPO(3,6,1)=   393086.80
      TIPO(3,6,2)=        3.74
      TIPO(3,6,3)=     2681.94
      TIPO(3,7,1)=   393086.80
      TIPO(3,7,2)=        3.74
      TIPO(3,7,3)=     2681.94
      TIPO(3,8,1)=   120792.10
      TIPO(3,8,2)=        4.10
      TIPO(3,8,3)=      472.79
      TIPO(4,4,1)=   365263.20
      TIPO(4,4,2)=        3.65
      TIPO(4,4,3)=     2891.14
      TIPO(4,5,1)=   268571.00
      TIPO(4,5,2)=        3.86
      TIPO(4,5,3)=     1522.98
      TIPO(4,6,1)=   268571.00
      TIPO(4,6,2)=        3.86
      TIPO(4,6,3)=     1522.98
      TIPO(4,7,1)=   268571.00
      TIPO(4,7,2)=        3.86
      TIPO(4,7,3)=     1522.98
      TIPO(4,8,1)=   228279.00
      TIPO(4,8,2)=        4.52
      TIPO(4,8,3)=      502.08
      TIPO(5,5,1)=   195309.10
      TIPO(5,5,2)=        3.74
      TIPO(5,5,3)=     1334.70
      TIPO(5,6,1)=   195309.10
      TIPO(5,6,2)=        3.74
      TIPO(5,6,3)=     1334.70
      TIPO(5,7,1)=   195309.10
      TIPO(5,7,2)=        3.74
      TIPO(5,7,3)=     1334.70
      TIPO(5,8,1)=   295432.30
      TIPO(5,8,2)=        4.82
      TIPO(5,8,3)=      439.32
      TIPO(6,6,1)=   195309.10
      TIPO(6,6,2)=        3.74
      TIPO(6,6,3)=     1334.70
      TIPO(6,7,1)=   195309.10
      TIPO(6,7,2)=        3.74
      TIPO(6,7,3)=     1334.70
      TIPO(7,7,1)=   195309.10
      TIPO(7,7,2)=        3.74
      TIPO(7,7,3)=     1334.70
      TIPO(7,8,1)= 15095080.00
      TIPO(7,8,2)=        7.78
      TIPO(7,8,3)=      995.79
      TIPO(8,8,1)=    24158.42
      TIPO(8,8,2)=        4.01
      TIPO(8,8,3)=      109.20
C     SYMMETRIZE POTENTIAL PARAMETER MATRIX
      DO 2 I=1,15
      DO 2 J=I,15
      DO 2 K=1,3
 2    TIPO(J,I,K)=TIPO(I,J,K)
      RETURN
      END
      BLOCK DATA BLKD11
      COMMON/TIPI/ WEI(30),RAVDW(30),RAVRG(30),FL(30)
      COMMON/OPEC2/ PESO(120),CUTOFF,ILEVEL(5),ISPEN(120),TIPO(15,15,3),
     1 NATOM,NA,NAA,NB,NC,ND,NE,NF,NG,NH,NI,NL,NM,NEE,NEM,NEF,NEL,NEP,
     2 NDD,NDE,NDF,NDG,NDH
      DATA WEI/1.0,1.0,12.,14.,16.,16.,16.,1.0,35.5,21*0.0/        
      DATA RAVRG/0.3,0.3,0.67,0.63,0.66,0.66,0.66,0.30,0.8,21*0.0/
      DATA RAVDW/1.17,1.17,1.75,1.55,1.4,1.4,1.4,1.17,1.8,21*0.0/     
      DATA FL/' H',' H',' C',' N',' O',' O',' O',' H','CL',21*'  '/   
      END
      SUBROUTINE TESGEO (iswm,intern)        
      common/moldim/volu,dmomax,dmomed,dmomin
      COMMON/OPEC1/ALFA(7000,3),RM(800,3,3),QRG(120),NPE
      COMMON/OPEC2/ PESO(120),CUTOFF,ILEVEL(5),ISPEN(120),TIPO(15,15,3),
     1 NATOM,NA,NAA,NB,NC,ND,NE,NF,NG,NH,NI,NL,NM,NEE,NEM,NEF,NEL,NEP,
     2 NDD,NDE,NDF,NDG,NDH
      DIMENSION IBOUND(120,10)                 
      COMMON/TIPI/ WEI(30),RAVDW(30),RAVRG(30),FL(30)      
      PZZ=0.0174533
      PI=3.141594
      natop=natom
      if(iswm.eq.0) go to 770
c     double atoms if internal symmetry
      write(8,776)
      write(6,776)
 776  format(2x,'reconstructing the molecule')
      do 781 i=1,natom
      ik=i+nm
      kk=ik+natom
      ispen(i+natom)=ispen(i)
      go to (771,772,773), intern
 771  continue
c     center of symmetry
      do 701 j=1,3
 701  alfa(kk,j)=-alfa(ik,j)
      go to 774
 772  continue
c     twofold axis along y
      alfa(kk,1)=-alfa(ik,1)
      alfa(kk,2)=alfa(ik,2)
      alfa(kk,3)=-alfa(ik,3)
      go to 774
 773  continue
c     mirror plane perp. to y
      alfa(kk,1)= alfa(ik,1)
      alfa(kk,2)=-alfa(ik,2)
      alfa(kk,3)= alfa(ik,3)
 774  write(8,775) (alfa(ik,l),l=1,3),(alfa(kk,m),m=1,3)
      write(6,775) (alfa(ik,l),l=1,3),(alfa(kk,m),m=1,3)
 775  format(2x,3f10.4,2x,3f10.4)
 781  continue
      natop=2*natom
 770  DO 101 I=1,NATOP
      DO 101 J=1,10                                          
 101  IBOUND(I,J)=0                                                             
c     compute molecular dimensions                       
      dxmax=0.
      dymax=0.
      dzmax=0.
      DO 11 I=1,NATOP                                                           
      IBOND=0                                                                   
      IK=I+NM                                                                   
      ISP=ISPEN(I)                                                              
      DO 12 J=1,NATOP                                                           
      JSP=ISPEN(J)                                                              
      IF(I.EQ.J) GO TO 12                                                       
      JK=J+NM                                                                   
      rx=ALFA(IK,1)-ALFA(JK,1)
      rx=abs(rx)
      if(rx.gt.dxmax) dxmax=rx
      ry=ALFA(IK,2)-ALFA(JK,2)         
      ry=abs(ry)
      if(ry.gt.dymax) dymax=ry
      rz=ALFA(IK,3)-ALFA(JK,3)
      rz=abs(rz)
      if(rz.gt.dzmax) dzmax=rz
      r=sqrt(rx*rx+ry*ry+rz*rz)
      BOND=RAVRG(ISP)+RAVRG(JSP)                                                
      DELT=ABS(R- BOND)                                                         
      DISCR=DELT/BOND*100.                                                      
      IF((DISCR.GT.30.).AND.(R.GT.BOND)) GO TO 12                               
      IBOND=IBOND+1                                                             
      IF(IBOND.GT.10) GO TO 12                                                  
      IBOUND(I,IBOND)=J                                                         
      IF(DISCR.LT.20.) GO TO 12                                                 
 12   CONTINUE                                                                  
 11   CONTINUE
      dmomax=amax1(dxmax,dymax,dzmax)+3.0
      dmomin=amin1(dxmax,dymax,dzmax)+3.0
C     MOLECULAR VOLUME CALCULATION                                              
C     SPHERES AND CAPS, KITAIGORODSKI METHOD                                    
      SUMVOL=0.0                                                                
      AREST=0.0                                                                 
      DO 21 I=1,NATOP                                                           
      IK=I+NM                                                                   
      J=ISPEN(I)                                                                
      CAL1=0.0                                                                  
      DO 22 K=1,10                                                              
      IF(IBOUND(I,K).EQ.0) GO TO 22                                             
      IBK=IBOUND(I,K)                                                           
      L=ISPEN(IBK)                                                              
      RAX=RAVDW(J)+RAVDW(L)                                                     
      JK=IBK+NM                                                                 
      R=(ALFA(IK,1)-ALFA(JK,1))**2+(ALFA(IK,2)-ALFA(JK,2))**2         
      RACT=SQRT(R+(ALFA(IK,3)-ALFA(JK,3))**2)
      IF(RACT-RAX) 33,22,22                                                     
 33   H1=RAVDW(J)-(RAVDW(J)**2+RACT**2-RAVDW(L)**2)/(2.*RACT)                   
      CAL1=(1./3.)*PI*H1**2*(3.*RAVDW(J)-H1)+CAL1                               
 22   CONTINUE                                                                  
      SUMXXX=(4./3.)*PI*RAVDW(J)**3-CAL1                                 
      SUMVOL=SUMVOL+SUMXXX                                                      
 21   CONTINUE                                                                  
      volu=sumvol
      if(iswm.ne.0) volu=0.5*volu
      RETURN                                                                    
      END                                                                       
      SUBROUTINE BARIC(NATOM,PESO,NF)
C     COMPUTE CENTER OF MASS
      DIMENSION PESO(120)
      COMMON/OPEC1/ALFA(7000,3),RM(800,3,3),QRG(120),NPE
      DO 11 I=1,3
 11   ALFA(NF,I)= 0.0
      SUMS=0.
      DO 500 I=1,NATOM
      PESI=PESO(I)
      SUMS=SUMS+PESI
      ALFA(NF,1)=ALFA(NF,1)+ALFA(I,1)*PESI
      ALFA(NF,2)=ALFA(NF,2)+ALFA(I,2)*PESI
      ALFA(NF,3)=ALFA(NF,3)+ALFA(I,3)*PESI
  500 CONTINUE
      ALFA(NF,1)=ALFA(NF,1)/SUMS
      ALFA(NF,2)=ALFA(NF,2)/SUMS
      ALFA(NF,3)=ALFA(NF,3)/SUMS
      RETURN
      END
      SUBROUTINE INV(I,J)
      COMMON/OPEC1/ALFA(7000,3),RM(800,3,3),QRG(120),NPE
      R11=RM(I,1,1)
      R12=RM(I,1,2)
      R13=RM(I,1,3)
      R21=RM(I,2,1)
      R22=RM(I,2,2)
      R23=RM(I,2,3)
      R31=RM(I,3,1)
      R32=RM(I,3,2)
      R33=RM(I,3,3)
      DET=R11*R22*R33+R12*R23*R31+R21*R32*R13-R13*R22*R31
      DET=DET-R11*R23*R32-R12*R21*R33
      RM(J,1,1)=(R22*R33-R23*R32)/DET
      RM(J,2,1)=-(R21*R33-R23*R31)/DET
      RM(J,3,1)=(R21*R32-R22*R31)/DET
      RM(J,1,2)=-(R12*R33-R13*R32)/DET
      RM(J,2,2)=(R11*R33-R13*R31)/DET
      RM(J,3,2)=-(R11*R32-R12*R31)/DET
      RM(J,1,3)=(R12*R23-R13*R22)/DET
      RM(J,2,3)=-(R11*R23-R13*R21)/DET
      RM(J,3,3)=(R11*R22-R12*R21)/DET
      RETURN
      END
      SUBROUTINE JACOB (MIX,NIX)
C     DIAGONALIZE MATRIX RM(MIX),PUT EIGENVECTORS IN RM(NIX)
      DIMENSION F(3,3),V(3,3)
      COMMON/OPEC1/ALFA(7000,3),RM(800,3,3),QRG(120),NPE
      COMMON/OPEC2/ PESO(120),CUTOFF,ILEVEL(5),ISPEN(120),TIPO(15,15,3),
     1 idum(23)     
      DOUBLE PRECISION SINT,COST,FUNNO,FUNT
      N=3
      RHO=0.000001
      DO 50 I=1,3
      DO 50 J=1,3
      F(I,J)=RM(MIX,I,J)
 50   CONTINUE
      TE=0.0
      FUNNO=1.0
      DO 20 I=1,3
      DO 21 J=1,3
      V(I,J)=0.0
 21   CONTINUE
      V(I,I)=1.0
 20   CONTINUE
      DO 1 I=2,N
      K=I-1
      DO 1 J=1,K
      TE=TE+2.*F(I,J)*F(I,J)
 1    CONTINUE
      TE=SQRT(TE)
      MA=0
      A=N
    2 TE=TE/A
      IF(TE.LT.RHO)TE=RHO
    3 DO 14 II=2,N
      IJ=II-1
      DO 14 JJ=1,IJ
      IF (ABS(F(II,JJ))-TE)14,4,4
    4 MA=1
      V1=F(JJ,JJ)
      V2=F(II,JJ)
      V3=F(II,II)
      U=.5*(F(JJ,JJ)-F(II,II))
      IF(ABS(U)-RHO)5,6,6
    5 OMEGA=-1.0
      GO TO 7
   6  FUX=SQRT(F(II,JJ)*F(II,JJ)+U*U)
      OMEGA=-F(II,JJ)/FUX
      Z=1.
      IF (U.LT.0.)Z=-Z
      OMEGA=OMEGA*Z
 7    FUX=1.0-OMEGA*OMEGA
      FEX=2.0*(1.0+SQRT(FUX))
      SINT=OMEGA/SQRT(FEX)
      FUNT=FUNNO-SINT*SINT
      COST=SQRT(FUNT)
      DO 13 I=1,N
      IF(I-II)9,8,8
    8 TEM=F(I,JJ)*COST-F(I,II)*SINT
      F(I,II)=F(I,JJ)*SINT+F(I,II)*COST
      F(I,JJ)=TEM
      GO TO 12
    9 IF(I-JJ)10,11,11
   10 TEM=F(JJ,I)*COST-F(II,I)*SINT
      F(II,I)=F(JJ,I)*SINT+F(II,I)*COST
      F(JJ,I)=TEM
      GO TO 12
   11 TEM=F(I,JJ)*COST-F(II,I)*SINT
      F(II,I)=F(I,JJ)*SINT+F(II,I)*COST
      F(I,JJ)=TEM
   12 TEM=V(I,JJ)*COST-V(I,II)*SINT
      V(I,II)=V(I,JJ)*SINT+V(I,II)*COST
      V(I,JJ)=TEM
 13   CONTINUE
      F(JJ,JJ)=V1*COST*COST+V3*SINT*SINT-2.*V2*SINT*COST
      F(II,II)=V1*SINT*SINT+V3*COST*COST+2.*V2*SINT*COST
      F(II,JJ)=2.*U*SINT*COST+V2*(COST*COST-SINT*SINT)
   14 CONTINUE
      IF(MA-1)16,15,15
   15 MA=0
      GO TO 3
   16 IF(TE-RHO)17,17,2
C     EIGENVALUE ORDERING
 17   CONTINUE
 310  IF(F(1,1)-F(2,2)) 100,101,101
 101  IF(F(2,2)-F(3,3)) 102,102,103
 103  IND=6
      GO TO 200
 102  IF(F(1,1)-F(3,3)) 104,104,105
 104  IND=2
      GO TO 200
 105  IND=5
      GO TO 200
 100  IF(F(2,2)-F(3,3)) 107,107,108
 107  IND=1
      GO TO 200
 108  IF(F(1,1)-F(3,3)) 109,109,110
 109  IND=4
      GO TO 200
 110  IND=3
 200  GO TO (116,115,116,115,115,201),IND
 115  F33=F(2,2)
      F(2,2)=F(3,3)
      F(3,3)=F33
      DO 120 I=1,3
      VC=V(I,3)
      V(I,3)=V(I,2)
 120  V(I,2)=VC
 116  IF(IND.EQ.5) GO TO 201
      GO TO (118,119,119,118) ,IND
 118  F33=F(1,1)
      F(1,1)=F(3,3)
      F(3,3)=F33
      DO 220 I=1,3
      VC=V(I,3)
      V(I,3)=V(I,1)
 220  V(I,1)=VC
      GO TO 201
 119  F33=F(2,2)
      F(2,2)=F(1,1)
      F(1,1)=F33
      DO 221 I=1,3
      VC=V(I,1)
      V(I,1)=V(I,2)
 221  V(I,2)=VC
 201  DO 51 I=1,3
      DO 51 J=1,3
      RM(MIX,I,J)=0.0
 51   RM(NIX,I,J)=V(J,I)
      RETURN
       END
      SUBROUTINE MATORT (A,B,C,ALF,BET,GAM)       
C     COMPUTE ORTHOGONALIZATION MATRIX)
      COMMON/OPEC1/ALFA(7000,3),RM(800,3,3),QRG(120),NPE
      COMMON/OPEC2/ PESO(120),CUTOFF,ILEVEL(5),ISPEN(120),TIPO(15,15,3),
     1 NATOM,NA,NAA,NB,NC,ND,NE,NF,NG,NH,NI,NL,NM,NEE,NEM,NEF,NEL,NEP,
     2 NDD,NDE,NDF,NDG,NDH
      common/ndim/nwpe,nrm,nalf,nwatom,nalmax
      DO 20 I=1,3
 20   ALFA (NF,I)=0.0
      PZ=0.01745329
      CALF=COS(ALF*PZ)
      SALF=SIN(ALF*PZ)
      CBET=COS(BET*PZ)
      SBET=SIN(BET*PZ)
      CGAM=COS(GAM*PZ)
      SGAM=SIN(GAM*PZ)
      RM(NB,1,1)=A*SGAM
      RM(NB,1,2)=0.0
      RM(NB,1,3)=C/SGAM
      RM(NB,2,1)=A*CGAM
      RM(NB,2,2)=B
      RM(NB,2,3)=CALF
      RM(NB,3,1)=0.0
      RM(NB,3,2)=0.0
      RM(NB,3,3)=1.-CGAM*CGAM-CBET*CBET-RM(NB,2,3)**2
     1 +2.*CGAM*CBET*RM(NB,2,3)
      RM(NB,3,3)=RM(NB,1,3)*SQRT(RM (NB,3,3))
      RM(NB,1,3)=RM(NB,1,3)*(CBET-CGAM*RM(NB,2,3))
      RM(NB,2,3)=RM(NB,2,3)*C
      CALL INV (NB,NC)
      if(npe.eq.0) return
C     PREPARE SYMMETRY-RELATED MOLECULES
      DO 503 I=1,NPE                                                            
      IK=I+NH                                                                   
      IKK=I+NI                                                                  
 503  CALL PRTR (NB,IK,IKK)                                                     
      JL=NM                                                                     
      DO 510 I=1,NPE                                                            
      IK=I+NI                                                                   
      DO 511 J=1,NATOM                                                          
      JL=JL+1                                                                   
 21   CALL PRMA (NB,I,NDF)                                                      
      CALL PRTR (NDF,J,JL)                                                      
      CALL SOMA(JL,IK,JL)                                                       
 511  CONTINUE                                                                  
 510  CONTINUE                                                                  
      CALL BARIC(NATOM,PESO,NF)
      CALL PRTR (NB,NF,NG)
      RETURN
      END
      SUBROUTINE PRMA(J,K,I)
      COMMON/OPEC1/ALFA(7000,3),RM(800,3,3),QRG(120),NPE
      A11=RM(J,1,1)*RM(K,1,1)+RM(J,1,2)*RM(K,2,1)+RM(J,1,3)*RM(K,3,1)
      A12=RM(J,1,1)*RM(K,1,2)+RM(J,1,2)*RM(K,2,2)+RM(J,1,3)*RM(K,3,2)
      A13=RM(J,1,1)*RM(K,1,3)+RM(J,1,2)*RM(K,2,3)+RM(J,1,3)*RM(K,3,3)
      A21=RM(J,2,1)*RM(K,1,1)+RM(J,2,2)*RM(K,2,1)+RM(J,2,3)*RM(K,3,1)
      A22=RM(J,2,1)*RM(K,1,2)+RM(J,2,2)*RM(K,2,2)+RM(J,2,3)*RM(K,3,2)
      A23=RM(J,2,1)*RM(K,1,3)+RM(J,2,2)*RM(K,2,3)+RM(J,2,3)*RM(K,3,3)
      A31=RM(J,3,1)*RM(K,1,1)+RM(J,3,2)*RM(K,2,1)+RM(J,3,3)*RM(K,3,1)
      A32=RM(J,3,1)*RM(K,1,2)+RM(J,3,2)*RM(K,2,2)+RM(J,3,3)*RM(K,3,2)
      A33=RM(J,3,1)*RM(K,1,3)+RM(J,3,2)*RM(K,2,3)+RM(J,3,3)*RM(K,3,3)
      RM(I,1,1)=A11
      RM(I,1,2)=A12
      RM(I,1,3)=A13
      RM(I,2,1)=A21
      RM(I,2,2)=A22
      RM(I,2,3)=A23
      RM(I,3,1)=A31
      RM(I,3,2)=A32
      RM(I,3,3)=A33
      RETURN
      END
      SUBROUTINE PRTR (I,J,K)
      DIMENSION UG(3)
      COMMON/OPEC1/ALFA(7000,3),RM(800,3,3),QRG(120),NPE
      UG(1)=RM(I,1,1)*ALFA(J,1)+RM(I,1,2)*ALFA(J,2)+RM(I,1,3)*ALFA(J,3)
      UG(2)=RM(I,2,1)*ALFA(J,1)+RM(I,2,2)*ALFA(J,2)+RM(I,2,3)*ALFA(J,3)
      UG(3)=RM(I,3,1)*ALFA(J,1)+RM(I,3,2)*ALFA(J,2)+RM(I,3,3)*ALFA(J,3)
      ALFA(K,1)=UG(1)
      ALFA(K,2)=UG(2)
      ALFA(K,3)=UG(3)
      RETURN
      END
      SUBROUTINE SETUP (IWR) 
      COMMON/OPEC1/ALFA(7000,3),RM(800,3,3),QRG(120),NPE
      COMMON/OPEC2/ PESO(120),CUTOFF,ILEVEL(5),ISPEN(120),TIPO(15,15,3),
     1 NATOM,NA,NAA,NB,NC,ND,NE,NF,NG,NH,NI,NL,NM,NEE,NEM,NEF,NEL,NEP,
     2 NDD,NDE,NDF,NDG,NDH
      PZ=0.01745329
      i=1
      C1=0.0
      C2=0.0
      C3=0.0
      SOMX=0.0
      SOMY=0.0
      SOMZ=0.0
      IKU=I+NL
      ICE=I+NI
      CALL BARIC(NATOM,PESO,NF)
      CALL PRMA (NB,I,NDF)
      CALL PRTR (NDF,NF,NEE)
      CALL SOMA (NEE,ICE,IKU)
      ALFA(IKU,1)=-ALFA(IKU,1)
      ALFA(IKU,2)=-ALFA(IKU,2)
      ALFA(IKU,3)=-ALFA(IKU,3)
      DO 880 KK=1,NATOM
      TUNE=PESO(KK)
      IF(I-1) 880,882,882
 882  KKI=(I-1)*NATOM+NM+KK
 803  CALL SOMA (KKI,IKU,NEL)
      C1=C1+ALFA(NEL,1)*TUNE*ALFA(NEL,1)
      C2=C2+ALFA(NEL,2)*TUNE*ALFA(NEL,2)
      C3=C3+ALFA(NEL,3)*TUNE*ALFA(NEL,3)
      SOMX=SOMX-ALFA(NEL,1)*ALFA(NEL,2)*TUNE
      SOMY=SOMY-ALFA(NEL,1)*ALFA(NEL,3)*TUNE
      SOMZ=SOMZ-ALFA(NEL,2)*ALFA(NEL,3)*TUNE
 880  CONTINUE
      RM(NDH,1,1)=C2+C3
      RM(NDH,2,2)=C1+C3
      RM(NDH,3,3)=C1+C2
      RM(NDH,1,2)=SOMX
      RM(NDH,1,3)=SOMY
      RM(NDH,2,3)=SOMZ
      RM(NDH,2,1)=RM(NDH,1,2)
      RM(NDH,3,1)=RM(NDH,1,3)
      RM(NDH,3,2)=RM(NDH,2,3)
      IKKO=I+NA
      CALL JACOB (NDH,IKKO)
      RM(IKKO,3,1)=RM(IKKO,1,2)*RM(IKKO,2,3)-RM(IKKO,1,3)*RM(IKKO,2,2)
      RM(IKKO,3,2)=RM(IKKO,1,3)*RM(IKKO,2,1)-RM(IKKO,1,1)*RM(IKKO,2,3)
      RM(IKKO,3,3)=RM(IKKO,1,1)*RM(IKKO,2,2)-RM(IKKO,1,2)*RM(IKKO,2,1)
      inve=i+naa
      call inv(ikko,inve) 
      IF(IWR.NE.0) CALL WRMA(iku,ikko,0)        
      RETURN
      END
      SUBROUTINE SOMA (I,J,K)
      COMMON/OPEC1/ALFA(7000,3),RM(800,3,3),QRG(120),NPE
      ALFA(K,1)=ALFA(I,1)+ALFA(J,1)
      ALFA(K,2)=ALFA(I,2)+ALFA(J,2)
      ALFA(K,3)=ALFA(I,3)+ALFA(J,3)
      RETURN
      END
      SUBROUTINE MATFIL(I,C1,S1,C2,S2,C3,S3)
      COMMON/OPEC1/ALFA(7000,3),RM(800,3,3),QRG(120),NPE
      RM(I,1,1)=C2*C3
      RM(I,1,2)=-C1*S3+S1*S2*C3
      RM(I,1,3)=S1*S3+C1*S2*C3
      RM(I,2,1)=C2*S3
      RM(I,2,2)=C1*C3+S1*S2*S3
      RM(I,2,3)=-S1*C3+C1*S2*S3
      RM(I,3,1)=-S2
      RM(I,3,2)=S1*C2
      RM(I,3,3)=C1*C2
 5    RETURN
      END
      SUBROUTINE DLTALF(I,J,RRXX)
      COMMON/OPEC1/ALFA(7000,3),RM(800,3,3),QRG(120),NPE
      RRXX=(ALFA(I,1)-ALFA(J,1))**2+
     1     (ALFA(I,2)-ALFA(J,2))**2+(ALFA(I,3)-ALFA(J,3))**2
      RRXX=SQRT(RRXX)
      RETURN
      END
      SUBROUTINE DIF (J,K,I)
      COMMON/OPEC1/ALFA(7000,3),RM(800,3,3),QRG(120),NPE
      ALFA(I,1)=ALFA(J,1)-ALFA(K,1)
      ALFA(I,2)=ALFA(J,2)-ALFA(K,2)
      ALFA(I,3)=ALFA(J,3)-ALFA(K,3)
      RETURN
      END
      subroutine sorter   
      COMMON /merge/ FAM(3000,8),PORIG(3000,6)
      COMMON/MINI/KI(12)
      DIMENSION PAR(6),PARN(6),SMAT(16,9),TV(16,3),ifound(3000)
      dimension bestp(6)
C     ISTM IS MAX NUMBER OF STRUCTURES
      ISTM=3000
C     ZERO STRUCTURE COUNTERS AND LINE COUNTER
 602  continue
      rewind 10
      ISTR=0
      NSTR=0
      LINE=0
      ISC2=0
      inig=1             
      ihg=1                
      besten=0.0
C     START READING STRUCTURE DATA
 991  CONTINUE   
      READ(10,171,END=999) nustr,vc,en          
 171  format(14x,i5,2x,2f10.2)
      LINE=LINE+1
      read(10,178) ki,dmom
 178  format(12i1,f10.3)
      line=line+1
      read (10,179) idum                    
 179  format(4i5,2f10.2)
      line=line+1
      READ(10,177) a,b,c,alf,bet,gam
 177  FORMAT(6f10.4)
      LINE=LINE+1
 2    FORMAT(2i5,60x,12i1)
      NSTR=NSTR+1
C     NIGGLI CELL REDUCTION
      PAR(1)=A
      PAR(2)=B
      PAR(3)=C
      PAR(4)=ALF
      PAR(5)=BET
      PAR(6)=GAM
c     save best structure
      if(en.gt.besten) go to 181
      besten=en
      do 182 i=1,6
 182  bestp(i)=par(i)
 181  continue
      CALL NIGGLI (PAR,PARN)
      A=PARN(1)
      B=PARN(2)
      C=PARN(3) 
      ALF=PARN(4) 
      BET=PARN(5) 
      GAM=PARN(6)  
C     READ AND SKIP ATOMIC COORDINATES
      natomx=0
 4    continue           
      READ(10,5) idummy
 5    FORMAT(I5)
      LINE=LINE+1
      natomx=natomx+1
      if(idummy.ne.999) go to 4
      natomx=natomx-1
      do 992 i=1,16      
      read(10,173) (smat(i,l),l=1,9)
 173  format(9f5.1)
      if(smat(i,1).gt.1.) go to 993
      line=line+1
      read(10,173) (tv(i,k),k=1,3)
      line=line+1
 992  continue
 993  continue
      do 994 i=1,4
 994  read(10,995) idum
 995  format(i1)
C     CHECK IF STRUCTURE IS A NEW ONE
 251  CONTINUE      
      TOLANG=1.0
C     SKIP CHECK IF THIS IS THE FIRST STRUCTURE
      IF(ISTR.EQ.0) GO TO 14
      DO 122 K=1,ISTR
      tole=0.01*(en+fam(k,8))*0.5
      tole=abs(tole)
      TOLA=0.020*(A+FAM(K,1))*0.5
      TOLB=0.020*(B+FAM(K,2))*0.5
      TOLC=0.020*(C+FAM(K,3))*0.5
      TOLV=0.030*(VC+FAM(K,7))*0.5
      IS=0
      IF(ABS(A-FAM(K,1)).GT.TOLA) IS=1
      IF(ABS(B-FAM(K,2)).GT.TOLB) IS=1
      IF(ABS(C-FAM(K,3)).GT.TOLC) IS=1
      ABE=ABS(ALF-FAM(K,4))
      ABF=ABS(180.-ALF-FAM(K,4))
      IF(ABE.GT.TOLANG.AND.ABF.GT.TOLANG) IS=1
      BBE=ABS(BET-FAM(K,5))
      BBF=ABS(180.-BET-FAM(K,5))
      IF(BBE.GT.TOLANG.AND.BBF.GT.TOLANG) IS=1
      GBE=ABS(GAM-FAM(K,6))
      GBF=ABS(180.-GAM-FAM(K,6))
      IF(GBE.GT.TOLANG.AND.GBF.GT.TOLANG) IS=1
      IF(ABS(VC-FAM(K,7)).GT.TOLV) IS=1
      IF(ABS(EN-FAM(K,8)).GT.TOLE) IS=1
      IF(IS.NE.0) GO TO 122
C     IS=0, THE STRUCTURE IS NOT NEW
      ISC2=ISC2+1
      GO TO 991
 122  CONTINUE
  14  ISTR=ISTR+1
      if(istr.gt.istm) go to 999
      CALL STO(ISTR,A,B,C,ALF,BET,GAM,VC,EN,PAR)
      GO TO 991
c     end first reading of tape 10
 999  CONTINUE
      WRITE(8,12) NSTR,ISTR,ISC2
 12   FORMAT(I6,1X,'STRUCTURES READ',I6,1X,'ACCEPTED',2X,I6,
     2 1x,'DISCARDED AS DUPLICATE'/)
c     stop if nothing found
      if(nstr.eq.0) stop
      write(8,183) besten,(bestp(k),k=1,6)
 183  format(1x,'Best energy',f10.2,2x,'cell',3f10.3,3f10.2)
      rewind 10
      noptim=0
      do 1778 i=1,istr
 1778 ifound(i)=0
c     prepare new tape (unit 11) with sorted structures
 71   continue       
      READ(10,171,END=88) nustr,vc,en
      read(10,178) ki,dmom
      read (10,179) idum
      READ(10,177) a,b,c,al,be,ga
      ISORT=0
      DO 13 I=1,istr
      if(abs(a-porig(i,1)).gt.0.0) go to 13
      if(abs(b-porig(i,2)).gt.0.0) go to 13
      if(abs(c-porig(i,3)).gt.0.0) go to 13
      if(abs(vc-fam(i,7)).gt.0.0) go to 13
      if(abs(en-fam(i,8)).gt.0.0) go to 13
      if(ifound(i).eq.0) ISORT=1
      go to 21
 13   continue
      go to 22
 15   FORMAT(1X,A5,1X,6F7.2,F11.2,F8.2)
 21   if(isort.eq.0) go to 22
      noptim=noptim+1
      ifound(i)=1
      WRITE(11,66) noptim,vc,en
 66   format(2x,'structure n.',i5,2x,2f10.2,2x,'sorted')
      WRITE(11,67) ki,dmom
 67   FORMAT(12i1,f10.3)                           
      WRITE(11,68) 1010,31,0,10.,-10.,0,0,0,-5.
 68   FORMAT(3I5,2F10.1,3I5,10X,F7.1)
      WRITE(11,69) A,B,C,AL,BE,GA
 69   FORMAT(6F10.4)
 22   continue
      do 1772 i=1,natomx
      read(10,84) nat,x,y,z,pes,isp,q,ra
 23   format(9f5.2)
 84   format(i5,3f10.4,f10.2,4x,i5,f10.3,f5.2)
      if(isort.ne.0) WRITE(11,84) i,X,Y,Z,PES,ISP,Q,ra
 1772 continue
      read(10,995) idum
      npen=0
      do 990 i=1,16
      read(10,173) (smat(i,l),l=1,9)
      if(smat(i,1).gt.1.0) go to 1111
      npen=npen+1
      read(10,173) (tv(i,k),k=1,3)
 990  continue
 1111 continue
      do 899 i=1,4
 899  read(10,995) idum
      if(isort.eq.0) go to 71
      WRITE(11,84) 999
      do 1775 i=1,npen
      WRITE(11,23) (smat(i,k),k=1,9)
      WRITE(11,23) (tv(i,k),k=1,3)
 1775 continue
      write(11,23) 99.
      WRITE(11,26) 98,1,3,99,98
 26   FORMAT(I5/2I3/I3/I4)
      go to 71
c     file 11 is prepared for input to the final optimization module
 88   continue
      stop
      END     
      SUBROUTINE STO(ISTR,A,B,C,ALF,BET,GAM,VC,EN,PAR)
C     CHARACTER*2 SYM,SYMX
      COMMON /merge/ FAM(3000,8),PORIG(3000,6)
      DIMENSION PAR(6)
      FAM(ISTR,1)=A
      FAM(ISTR,2)=B
      FAM(ISTR,3)=C
      FAM(ISTR,4)=ALF
      FAM(ISTR,5)=BET
      FAM(ISTR,6)=GAM
      FAM(ISTR,7)=VC
      FAM(ISTR,8)=EN
      DO 15 I=1,6
 15   PORIG(ISTR,I)=PAR(I)
      RETURN
      END
      SUBROUTINE NIGGLI(PAR,PARN)
C-----This routine carries out the Niggli reduction using the
C-----Crivy & Gruber algorithm (Acta Cryst.(1976).A32,297).
      DIMENSION PAR(6),PARN(6)
      DIMENSION MT(3,3),AMT(3,3),CN(3),AN(3),ANIG(6) 
      DIMENSION C1(3),A1(3),C2(3),SC2(3),A2(3),SA2(3),CS(3),SN(3),T(3,3)
      RD=57.295779513
      DO 1 I=1,3
      C2(I)=PAR(I)
      A2(I)=PAR(I+3)/RD
      CS(I)=COS(A2(I))
      IF(ABS(CS(I)).LT.1E-6)CS(I)=0.
      SN(I)=SIN(A2(I))
      C1(I)=C2(I)
1     A1(I)=A2(I)
      A=C1(1)**2
      B=C1(2)**2
      C=C1(3)**2
      X=2*C1(2)*C1(3)*CS(1)
      E=2*C1(1)*C1(3)*CS(2)
      Z=2*C1(1)*C1(2)*CS(3)
      DO 2 I=1,3
      DO 2 J=1,3
      AMT(I,J)=0.0
      T(I,J)=0.0
      IF(I.EQ.J)  T(I,J)=1.
2     IF(I.EQ.J)AMT(I,J)=1.
      NN=0
3     CONTINUE
      IF(ABS(X).LT.1E-5)X=0.0
      IF(ABS(E).LT.1E-5)E=0.0
      IF(ABS(Z).LT.1E-5)Z=0.0
      IF(ABS(A-B).LT.1E-5)B=A
      IF(ABS(A-C).LT.1E-5)C=A
      IF(ABS(B-C).LT.1E-5)C=B
      IF(ABS(ABS(X)-ABS(A)).LT.1E-5)X=ISG(X)*A
      IF(ABS(ABS(E)-ABS(A)).LT.1E-5)E=ISG(E)*A
      IF(ABS(ABS(Z)-ABS(A)).LT.1E-5)Z=ISG(Z)*A
      IF(ABS(ABS(X)-ABS(B)).LT.1E-5)X=ISG(X)*B
      IF(ABS(ABS(E)-ABS(B)).LT.1E-5)E=ISG(E)*B
      IF(ABS(ABS(Z)-ABS(B)).LT.1E-5)Z=ISG(Z)*B
      IF(ABS(ABS(X)-ABS(C)).LT.1E-5)X=ISG(X)*C
      IF(ABS(ABS(E)-ABS(C)).LT.1E-5)E=ISG(E)*C
      IF(ABS(ABS(Z)-ABS(C)).LT.1E-5)Z=ISG(Z)*C
      NN=NN+1
      IF(NN.GT.1000) RETURN
      IF(A.GT.B.OR.(A.EQ.B.AND.ABS(X).GT.ABS(E)))GO TO 4
      GO TO 6
C-----Step 1
4     DP=A
      A=B
      B=DP
      DP=X
      X=E
      E=DP
      DO 5 I=1,3
      DO 5 J=1,3
5     MT(I,J)=0
      MT(1,2)=1
      MT(2,1)=1
      MT(3,3)=1
      CALL MTP3(MT,AMT)
6     CONTINUE
      IF(B.GT.C.OR.(B.EQ.C.AND.ABS(E).GT.ABS(Z)))GO TO 7
      GO TO 9
C-----Step 2
7     DP=B
      B=C
      C=DP
      DP=E
      E=Z
      Z=DP
      DO 8 I=1,3
      DO 8 J=1,3
8     MT(I,J)=0
      MT(1,1)=1
      MT(2,3)=1
      MT(3,2)=1
      CALL MTP3(MT,AMT)
      GO TO 3
C-----Step 3
9     DO 10 I=1,3
      DO 10 J=1,3
10    MT(I,J)=0.0
      DO 11 I=1,3
11    MT(I,I)=1
      Y=X*E*Z
      IF(Y.LE.0.0) GO TO 33
      MT(1,1)=ISG(Y)*ISG(X)
      MT(2,2)=ISG(Y)*ISG(E)
      MT(3,3)=ISG(Y)*ISG(Z)
      CALL MTP3(MT,AMT)
      X=ABS(X)
      E=ABS(E)
      Z=ABS(Z)
      GO TO 12
C-----Step 4
33    IF(Y.EQ.0.0) GO TO 34
      MT(1,1)=ISG(Y)*ISG(X)
      MT(2,2)=ISG(Y)*ISG(E)
      MT(3,3)=ISG(Y)*ISG(Z)
      CALL MTP3(MT,AMT)
      X=-1.0*ABS(X)
      E=-1.0*ABS(E)
      Z=-1.0*ABS(Z)
      GO TO 12
34    CALL MTP3(MT,AMT)
12    IF(ABS(X).GT.B.OR.(X.EQ.B.AND.(2.*E).LT.Z).OR.
     1 (X.EQ.(-B).AND.Z.LT.0.0)) GO TO 16
      GO TO 18
C-----Step 5
16    DO 17 I=1,3
      DO 17 J=1,3
      MT(I,J)=0
17    IF(I.EQ.J)MT(I,J)=1
      MT(3,2)=-(ISG(X)*ISG(E)*ISG(Z))
      IF((X*E*Z).EQ.0.0)MT(3,2)=-1
      IF(X.EQ.0.0.AND.E.EQ.0.0.AND.Z.NE.0.0)MT(3,2)=-ISG(Z)
      IF(X.EQ.0.0.AND.E.NE.0.0.AND.Z.EQ.0.0)MT(3,2)=-ISG(E)
      IF(X.NE.0.0.AND.E.EQ.0.0.AND.Z.EQ.0.0)MT(3,2)=-ISG(X)
      CALL MTP3(MT,AMT)
      C=B+C-X*ISG(X)
      E=E-Z*ISG(X)
      X=X-2.*B*ISG(X)
      GO TO 3
C-----Step 6
18    IF(ABS(E).GT.A.OR.(E.EQ.A.AND.(2.*X).LT.Z).OR.
     1 (E.EQ.(-A).AND.Z.LT.0.)) GO TO 19
      GO TO 21
19    DO 20 I=1,3
      DO 20 J=1,3
      MT(I,J)=0
20    IF(I.EQ.J)MT(I,J)=1
      MT(3,1)=-(ISG(X)*ISG(E)*ISG(Z))
      IF((X*E*Z).EQ.0.0)MT(3,1)=-1
      IF(X.EQ.0.0.AND.E.EQ.0.0.AND.Z.NE.0.0)MT(3,1)=-ISG(Z)
      IF(X.EQ.0.0.AND.E.NE.0.0.AND.Z.EQ.0.0)MT(3,1)=-ISG(E)
      IF(X.NE.0.0.AND.E.EQ.0.0.AND.Z.EQ.0.0)MT(3,1)=-ISG(X)
      CALL MTP3(MT,AMT)
      C=A+C-E*ISG(E)
      X=X-Z*ISG(E)
      E=E-2.*A*ISG(E)
      GO TO 3
21    CONTINUE
C-----Step 7
      IF(ABS(Z).GT.A.OR.(Z.EQ.A.AND.(2.*X).LT.E).OR.
     1 (Z.EQ.(-A).AND.E.LT.0.)) GO TO 22
      GO TO 24
22    DO 23 I=1,3
      DO 23 J=1,3
      MT(I,J)=0
23    IF(I.EQ.J)MT(I,J)=1
      MT(2,1)=-(ISG(X)*ISG(E)*ISG(Z))
      IF((X*E*Z).EQ.0.0)MT(2,1)=-1
      IF(X.EQ.0.0.AND.E.EQ.0.0.AND.Z.NE.0.0)MT(2,1)=-ISG(Z)
      IF(X.EQ.0.0.AND.E.NE.0.0.AND.Z.EQ.0.0)MT(2,1)=-ISG(E)
      IF(X.NE.0.0.AND.E.EQ.0.0.AND.Z.EQ.0.0)MT(2,1)=-ISG(X)
      CALL MTP3(MT,AMT)
      B=A+B-Z*ISG(Z)
      X=X-E*ISG(Z)
      Z=Z-2.*A*ISG(Z)
      GO TO 3
24    DP=X+E+Z+A+B
      IF(DP.LT.0.0.OR.(DP.EQ.0.0.AND.(2.*(A+E)+Z).GT.0.0)) GO TO 25
      GO TO 27
C-----Step 8
25    C=A+B+C+X+E+Z
      X=2.*B+X+Z
      E=2.*A+E+Z
      DO 26 I=1,3
      DO 26 J=1,3
      MT(I,J)=0
26    IF(I.EQ.J)MT(I,J)=1
      MT(3,1)=1
      MT(3,2)=1
      CALL MTP3(MT,AMT)
      GO TO 3
C-----Calculation and printing of final parameters
27    ANIG(1)=A
      ANIG(2)=B
      ANIG(3)=C
      ANIG(4)=X/2.
      ANIG(5)=E/2.
      ANIG(6)=Z/2.
      DO 28 I=1,3
28    CN(I)=SQRT(ANIG(I))
      AN(1)=ANIG(4)/(CN(2)*CN(3))
      AN(2)=ANIG(5)/(CN(1)*CN(3))
      AN(3)=ANIG(6)/(CN(1)*CN(2))
      DO 30 I=1,3
      IF(ABS(AN(I)).LE.1E-6)GO TO 29
      AN(I)=ATAN2(SQRT(1.-AN(I)**2),AN(I))
      AN(I)=AN(I)*RD
      GO TO 30
29    AN(I)=90.
30    CONTINUE
      DO 99 I=1,3
      PARN(I)=CN(I)
      PARN(I+3)=AN(I)
99    CONTINUE
      RETURN
      END
      SUBROUTINE MTP3(M,AM)
C-----This routine multiplies two 3x3 matrices, the first being
C-----integer, the latter real. The product is put in AM
      DIMENSION M(3,3),AM(3,3),AM1(3,3)
      DO 1 I=1,3
      DO 1 J=1,3
      AM1(I,J)=0.0
      DO 1 K=1,3
1     AM1(I,J)=AM1(I,J)+M(I,K)*AM(K,J)
      DO 2 I=1,3
      DO 2 J=1,3
2     AM(I,J)=AM1(I,J)
      RETURN
      END
      FUNCTION ISG(X)
      ISG=1
      IF(X.LT.0.0)ISG=-1
      RETURN
      END
